// A Bison parser, made by GNU Bison 3.8.2.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.


// Take the name prefix into account.
#define yylex   GringoNonGroundGrammar_lex

// First part of user prologue.
#line 58 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"


#include "gringo/input/nongroundparser.hh"
#include "gringo/input/programbuilder.hh"
#include <climits> 

#define BUILDER (lexer->builder())
#define LOGGER (lexer->logger())
#define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do {                                                               \
        if (N) {                                                       \
            (Current).beginFilename = YYRHSLOC (Rhs, 1).beginFilename; \
            (Current).beginLine     = YYRHSLOC (Rhs, 1).beginLine;     \
            (Current).beginColumn   = YYRHSLOC (Rhs, 1).beginColumn;   \
            (Current).endFilename   = YYRHSLOC (Rhs, N).endFilename;   \
            (Current).endLine       = YYRHSLOC (Rhs, N).endLine;       \
            (Current).endColumn     = YYRHSLOC (Rhs, N).endColumn;     \
        }                                                              \
        else {                                                         \
            (Current).beginFilename = YYRHSLOC (Rhs, 0).endFilename;   \
            (Current).beginLine     = YYRHSLOC (Rhs, 0).endLine;       \
            (Current).beginColumn   = YYRHSLOC (Rhs, 0).endColumn;     \
            (Current).endFilename   = YYRHSLOC (Rhs, 0).endFilename;   \
            (Current).endLine       = YYRHSLOC (Rhs, 0).endLine;       \
            (Current).endColumn     = YYRHSLOC (Rhs, 0).endColumn;     \
        }                                                              \
    }                                                                  \
    while (false)

using namespace Gringo;
using namespace Gringo::Input;

int GringoNonGroundGrammar_lex(void *value, Gringo::Location* loc, NonGroundParser *lexer) {
    return lexer->lex(value, *loc);
}


#line 81 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"


#include "grammar.hh"


// Unqualified %code blocks.
#line 96 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"


void NonGroundGrammar::parser::error(DefaultLocation const &l, std::string const &msg) {
    lexer->parseError(l, msg);
}


#line 96 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 28 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
namespace Gringo { namespace Input { namespace NonGroundGrammar {
#line 189 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"

  /// Build a parser object.
  parser::parser (Gringo::Input::NonGroundParser *lexer_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      lexer (lexer_yyarg)
  {}

  parser::~parser ()
  {}

  parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------.
  | symbol.  |
  `---------*/

  // basic_symbol.
  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value (that.value)
    , location (that.location)
  {}


  /// Constructor for valueless symbols.
  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, YY_MOVE_REF (location_type) l)
    : Base (t)
    , value ()
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, YY_RVREF (value_type) v, YY_RVREF (location_type) l)
    : Base (t)
    , value (YY_MOVE (v))
    , location (YY_MOVE (l))
  {}


  template <typename Base>
  parser::symbol_kind_type
  parser::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


  template <typename Base>
  bool
  parser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    value = YY_MOVE (s.value);
    location = YY_MOVE (s.location);
  }

  // by_kind.
  parser::by_kind::by_kind () YY_NOEXCEPT
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  parser::by_kind::by_kind (by_kind&& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  parser::by_kind::by_kind (const by_kind& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {}

  parser::by_kind::by_kind (token_kind_type t) YY_NOEXCEPT
    : kind_ (yytranslate_ (t))
  {}



  void
  parser::by_kind::clear () YY_NOEXCEPT
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  void
  parser::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  parser::symbol_kind_type
  parser::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }


  parser::symbol_kind_type
  parser::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }



  // by_state.
  parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  parser::symbol_kind_type
  parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  parser::stack_symbol_type::stack_symbol_type ()
  {}

  parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.value), YY_MOVE (that.location))
  {
#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.value), YY_MOVE (that.location))
  {
    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    value = that.value;
    location = that.location;
    return *this;
  }

  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    value = that.value;
    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);

    // User destructor.
    YY_USE (yysym.kind ());
  }

#if YYDEBUG
  template <typename Base>
  void
  parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  parser::yypop_ (int n) YY_NOEXCEPT
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  parser::debug_level_type
  parser::debug_level () const
  {
    return yydebug_;
  }

  void
  parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  parser::state_type
  parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  parser::yy_pact_value_is_default_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  parser::yy_table_value_is_error_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yytable_ninf_;
  }

  int
  parser::operator() ()
  {
    return parse ();
  }

  int
  parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            yyla.kind_ = yytranslate_ (yylex (&yyla.value, &yyla.location, lexer));
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* If YYLEN is nonzero, implement the default value of the
         action: '$$ = $1'.  Otherwise, use the top of the stack.

         Otherwise, the following line sets YYLHS.VALUE to garbage.
         This behavior is undocumented and Bison users should not rely
         upon it.  */
      if (yylen)
        yylhs.value = yystack_[yylen - 1].value;
      else
        yylhs.value = yystack_[0].value;

      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 7: // statement: "."
#line 331 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                        { lexer->parseError(yylhs.location, "syntax error, unexpected ."); }
#line 662 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 10: // identifier: "<IDENTIFIER>"
#line 337 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                    { (yylhs.value.str) = (yystack_[0].value.str); }
#line 668 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 11: // identifier: "default"
#line 338 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                    { (yylhs.value.str) = (yystack_[0].value.str); }
#line 674 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 12: // identifier: "override"
#line 339 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                    { (yylhs.value.str) = (yystack_[0].value.str); }
#line 680 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 13: // constterm: constterm "^" constterm
#line 346 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, BinOp::XOR, (yystack_[2].value.term), (yystack_[0].value.term)); }
#line 686 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 14: // constterm: constterm "?" constterm
#line 347 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, BinOp::OR, (yystack_[2].value.term), (yystack_[0].value.term)); }
#line 692 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 15: // constterm: constterm "&" constterm
#line 348 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, BinOp::AND, (yystack_[2].value.term), (yystack_[0].value.term)); }
#line 698 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 16: // constterm: constterm "+" constterm
#line 349 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, BinOp::ADD, (yystack_[2].value.term), (yystack_[0].value.term)); }
#line 704 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 17: // constterm: constterm "-" constterm
#line 350 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, BinOp::SUB, (yystack_[2].value.term), (yystack_[0].value.term)); }
#line 710 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 18: // constterm: constterm "*" constterm
#line 351 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, BinOp::MUL, (yystack_[2].value.term), (yystack_[0].value.term)); }
#line 716 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 19: // constterm: constterm "/" constterm
#line 352 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, BinOp::DIV, (yystack_[2].value.term), (yystack_[0].value.term)); }
#line 722 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 20: // constterm: constterm "\\" constterm
#line 353 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, BinOp::MOD, (yystack_[2].value.term), (yystack_[0].value.term)); }
#line 728 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 21: // constterm: constterm "**" constterm
#line 354 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, BinOp::POW, (yystack_[2].value.term), (yystack_[0].value.term)); }
#line 734 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 22: // constterm: "-" constterm
#line 355 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, UnOp::NEG, (yystack_[0].value.term)); }
#line 740 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 23: // constterm: "~" constterm
#line 356 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, UnOp::NOT, (yystack_[0].value.term)); }
#line 746 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 24: // constterm: "(" ")"
#line 357 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, BUILDER.termvec(), false); }
#line 752 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 25: // constterm: "(" "," ")"
#line 358 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, BUILDER.termvec(), true); }
#line 758 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 26: // constterm: "(" consttermvec ")"
#line 359 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, (yystack_[1].value.termvec), false); }
#line 764 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 27: // constterm: "(" consttermvec "," ")"
#line 360 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, (yystack_[2].value.termvec), true); }
#line 770 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 28: // constterm: identifier "(" constargvec ")"
#line 361 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, String::fromRep((yystack_[3].value.str)), (yystack_[1].value.termvecvec), false); }
#line 776 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 29: // constterm: "@" identifier "(" constargvec ")"
#line 362 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, String::fromRep((yystack_[3].value.str)), (yystack_[1].value.termvecvec), true); }
#line 782 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 30: // constterm: "|" constterm "|"
#line 363 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, UnOp::ABS, (yystack_[1].value.term)); }
#line 788 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 31: // constterm: identifier
#line 364 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, Symbol::createId(String::fromRep((yystack_[0].value.str)))); }
#line 794 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 32: // constterm: "@" identifier
#line 365 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, String::fromRep((yystack_[0].value.str)), BUILDER.termvecvec(BUILDER.termvecvec(), BUILDER.termvec()), true); }
#line 800 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 33: // constterm: "<NUMBER>"
#line 366 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, Symbol::createNum((yystack_[0].value.num))); }
#line 806 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 34: // constterm: "<STRING>"
#line 367 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, Symbol::createStr(String::fromRep((yystack_[0].value.str)))); }
#line 812 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 35: // constterm: "#inf"
#line 368 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, Symbol::createInf()); }
#line 818 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 36: // constterm: "#sup"
#line 369 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { (yylhs.value.term) = BUILDER.term(yylhs.location, Symbol::createSup()); }
#line 824 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 37: // consttermvec: constterm
#line 375 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                         { (yylhs.value.termvec) = BUILDER.termvec(BUILDER.termvec(), (yystack_[0].value.term));  }
#line 830 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 38: // consttermvec: consttermvec "," constterm
#line 376 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                         { (yylhs.value.termvec) = BUILDER.termvec((yystack_[2].value.termvec), (yystack_[0].value.term));  }
#line 836 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 39: // constargvec: consttermvec
#line 380 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                      { (yylhs.value.termvecvec) = BUILDER.termvecvec(BUILDER.termvecvec(), (yystack_[0].value.termvec));  }
#line 842 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 40: // constargvec: %empty
#line 381 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                      { (yylhs.value.termvecvec) = BUILDER.termvecvec(BUILDER.termvecvec(), BUILDER.termvec());  }
#line 848 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 41: // term: term ".." term
#line 387 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.term(yylhs.location, (yystack_[2].value.term), (yystack_[0].value.term)); }
#line 854 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 42: // term: term "^" term
#line 388 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.term(yylhs.location, BinOp::XOR, (yystack_[2].value.term), (yystack_[0].value.term)); }
#line 860 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 43: // term: term "?" term
#line 389 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.term(yylhs.location, BinOp::OR, (yystack_[2].value.term), (yystack_[0].value.term)); }
#line 866 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 44: // term: term "&" term
#line 390 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.term(yylhs.location, BinOp::AND, (yystack_[2].value.term), (yystack_[0].value.term)); }
#line 872 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 45: // term: term "+" term
#line 391 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.term(yylhs.location, BinOp::ADD, (yystack_[2].value.term), (yystack_[0].value.term)); }
#line 878 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 46: // term: term "-" term
#line 392 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.term(yylhs.location, BinOp::SUB, (yystack_[2].value.term), (yystack_[0].value.term)); }
#line 884 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 47: // term: term "*" term
#line 393 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.term(yylhs.location, BinOp::MUL, (yystack_[2].value.term), (yystack_[0].value.term)); }
#line 890 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 48: // term: term "/" term
#line 394 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.term(yylhs.location, BinOp::DIV, (yystack_[2].value.term), (yystack_[0].value.term)); }
#line 896 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 49: // term: term "\\" term
#line 395 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.term(yylhs.location, BinOp::MOD, (yystack_[2].value.term), (yystack_[0].value.term)); }
#line 902 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 50: // term: term "**" term
#line 396 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.term(yylhs.location, BinOp::POW, (yystack_[2].value.term), (yystack_[0].value.term)); }
#line 908 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 51: // term: "-" term
#line 397 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.term(yylhs.location, UnOp::NEG, (yystack_[0].value.term)); }
#line 914 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 52: // term: "~" term
#line 398 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.term(yylhs.location, UnOp::NOT, (yystack_[0].value.term)); }
#line 920 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 53: // term: "(" tuplevec ")"
#line 399 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.pool(yylhs.location, (yystack_[1].value.termvec)); }
#line 926 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 54: // term: identifier "(" argvec ")"
#line 400 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.term(yylhs.location, String::fromRep((yystack_[3].value.str)), (yystack_[1].value.termvecvec), false); }
#line 932 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 55: // term: "@" identifier "(" argvec ")"
#line 401 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.term(yylhs.location, String::fromRep((yystack_[3].value.str)), (yystack_[1].value.termvecvec), true); }
#line 938 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 56: // term: "|" unaryargvec "|"
#line 402 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.term(yylhs.location, UnOp::ABS, (yystack_[1].value.termvec)); }
#line 944 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 57: // term: identifier
#line 403 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.term(yylhs.location, Symbol::createId(String::fromRep((yystack_[0].value.str)))); }
#line 950 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 58: // term: "@" identifier
#line 404 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.term(yylhs.location, String::fromRep((yystack_[0].value.str)), BUILDER.termvecvec(BUILDER.termvecvec(), BUILDER.termvec()), true); }
#line 956 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 59: // term: "<NUMBER>"
#line 405 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.term(yylhs.location, Symbol::createNum((yystack_[0].value.num))); }
#line 962 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 60: // term: "<STRING>"
#line 406 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.term(yylhs.location, Symbol::createStr(String::fromRep((yystack_[0].value.str)))); }
#line 968 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 61: // term: "#inf"
#line 407 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.term(yylhs.location, Symbol::createInf()); }
#line 974 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 62: // term: "#sup"
#line 408 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.term(yylhs.location, Symbol::createSup()); }
#line 980 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 63: // term: "<VARIABLE>"
#line 409 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.term(yylhs.location, String::fromRep((yystack_[0].value.str))); }
#line 986 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 64: // term: "<ANONYMOUS>"
#line 410 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                               { (yylhs.value.term) = BUILDER.term(yylhs.location, String("_")); }
#line 992 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 65: // unaryargvec: term
#line 416 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                 { (yylhs.value.termvec) = BUILDER.termvec(BUILDER.termvec(), (yystack_[0].value.term)); }
#line 998 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 66: // unaryargvec: unaryargvec ";" term
#line 417 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                 { (yylhs.value.termvec) = BUILDER.termvec((yystack_[2].value.termvec), (yystack_[0].value.term)); }
#line 1004 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 67: // ntermvec: term
#line 423 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                { (yylhs.value.termvec) = BUILDER.termvec(BUILDER.termvec(), (yystack_[0].value.term)); }
#line 1010 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 68: // ntermvec: ntermvec "," term
#line 424 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                { (yylhs.value.termvec) = BUILDER.termvec((yystack_[2].value.termvec), (yystack_[0].value.term)); }
#line 1016 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 69: // termvec: ntermvec
#line 428 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                  { (yylhs.value.termvec) = (yystack_[0].value.termvec); }
#line 1022 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 70: // termvec: %empty
#line 429 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                  { (yylhs.value.termvec) = BUILDER.termvec(); }
#line 1028 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 71: // tuple: ntermvec ","
#line 433 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                        { (yylhs.value.term) = BUILDER.term(yylhs.location, (yystack_[1].value.termvec), true); }
#line 1034 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 72: // tuple: ntermvec
#line 434 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                        { (yylhs.value.term) = BUILDER.term(yylhs.location, (yystack_[0].value.termvec), false); }
#line 1040 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 73: // tuple: ","
#line 435 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                        { (yylhs.value.term) = BUILDER.term(yylhs.location, BUILDER.termvec(), true); }
#line 1046 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 74: // tuple: %empty
#line 436 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                        { (yylhs.value.term) = BUILDER.term(yylhs.location, BUILDER.termvec(), false); }
#line 1052 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 75: // tuplevec_sem: tuple ";"
#line 439 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                   { (yylhs.value.termvec) = BUILDER.termvec(BUILDER.termvec(), (yystack_[1].value.term)); }
#line 1058 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 76: // tuplevec_sem: tuplevec_sem tuple ";"
#line 440 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                   { (yylhs.value.termvec) = BUILDER.termvec((yystack_[2].value.termvec), (yystack_[1].value.term)); }
#line 1064 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 77: // tuplevec: tuple
#line 443 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                               { (yylhs.value.termvec) = BUILDER.termvec(BUILDER.termvec(), (yystack_[0].value.term)); }
#line 1070 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 78: // tuplevec: tuplevec_sem tuple
#line 444 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                               { (yylhs.value.termvec) = BUILDER.termvec((yystack_[1].value.termvec), (yystack_[0].value.term)); }
#line 1076 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 79: // argvec: termvec
#line 447 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                               { (yylhs.value.termvecvec) = BUILDER.termvecvec(BUILDER.termvecvec(), (yystack_[0].value.termvec)); }
#line 1082 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 80: // argvec: argvec ";" termvec
#line 448 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                               { (yylhs.value.termvecvec) = BUILDER.termvecvec((yystack_[2].value.termvecvec), (yystack_[0].value.termvec)); }
#line 1088 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 81: // binaryargvec: term "," term
#line 452 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                  { (yylhs.value.termvecvec) = BUILDER.termvecvec(BUILDER.termvecvec(), BUILDER.termvec(BUILDER.termvec(BUILDER.termvec(), (yystack_[2].value.term)), (yystack_[0].value.term))); }
#line 1094 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 82: // binaryargvec: binaryargvec ";" term "," term
#line 453 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                  { (yylhs.value.termvecvec) = BUILDER.termvecvec((yystack_[4].value.termvecvec), BUILDER.termvec(BUILDER.termvec(BUILDER.termvec(), (yystack_[2].value.term)), (yystack_[0].value.term))); }
#line 1100 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 83: // cmp: ">"
#line 463 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
             { (yylhs.value.rel) = Relation::GT; }
#line 1106 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 84: // cmp: "<"
#line 464 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
             { (yylhs.value.rel) = Relation::LT; }
#line 1112 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 85: // cmp: ">="
#line 465 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
             { (yylhs.value.rel) = Relation::GEQ; }
#line 1118 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 86: // cmp: "<="
#line 466 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
             { (yylhs.value.rel) = Relation::LEQ; }
#line 1124 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 87: // cmp: "="
#line 467 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
             { (yylhs.value.rel) = Relation::EQ; }
#line 1130 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 88: // cmp: "!="
#line 468 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
             { (yylhs.value.rel) = Relation::NEQ; }
#line 1136 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 89: // atom: identifier
#line 472 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                      { (yylhs.value.term) = BUILDER.predRep(yylhs.location, false, String::fromRep((yystack_[0].value.str)), BUILDER.termvecvec(BUILDER.termvecvec(), BUILDER.termvec())); }
#line 1142 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 90: // atom: identifier "(" argvec ")"
#line 473 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                      { (yylhs.value.term) = BUILDER.predRep(yylhs.location, false, String::fromRep((yystack_[3].value.str)), (yystack_[1].value.termvecvec)); }
#line 1148 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 91: // atom: "-" identifier
#line 474 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                      { (yylhs.value.term) = BUILDER.predRep(yylhs.location, true, String::fromRep((yystack_[0].value.str)), BUILDER.termvecvec(BUILDER.termvecvec(), BUILDER.termvec())); }
#line 1154 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 92: // atom: "-" identifier "(" argvec ")"
#line 475 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                      { (yylhs.value.term) = BUILDER.predRep(yylhs.location, true, String::fromRep((yystack_[3].value.str)), (yystack_[1].value.termvecvec)); }
#line 1160 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 93: // rellitvec: cmp term
#line 479 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                    { (yylhs.value.rellitvec) = BUILDER.rellitvec(yylhs.location, (yystack_[1].value.rel), (yystack_[0].value.term)); }
#line 1166 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 94: // rellitvec: rellitvec cmp term
#line 480 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                    { (yylhs.value.rellitvec) = BUILDER.rellitvec(yylhs.location, (yystack_[2].value.rellitvec), (yystack_[1].value.rel), (yystack_[0].value.term)); }
#line 1172 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 95: // literal: "#true"
#line 484 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                   { (yylhs.value.lit) = BUILDER.boollit(yylhs.location, true); }
#line 1178 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 96: // literal: "not" "#true"
#line 485 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                   { (yylhs.value.lit) = BUILDER.boollit(yylhs.location, false); }
#line 1184 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 97: // literal: "not" "not" "#true"
#line 486 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                   { (yylhs.value.lit) = BUILDER.boollit(yylhs.location, true); }
#line 1190 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 98: // literal: "#false"
#line 487 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                   { (yylhs.value.lit) = BUILDER.boollit(yylhs.location, false); }
#line 1196 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 99: // literal: "not" "#false"
#line 488 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                   { (yylhs.value.lit) = BUILDER.boollit(yylhs.location, true); }
#line 1202 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 100: // literal: "not" "not" "#false"
#line 489 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                   { (yylhs.value.lit) = BUILDER.boollit(yylhs.location, false); }
#line 1208 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 101: // literal: atom
#line 490 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                   { (yylhs.value.lit) = BUILDER.predlit(yylhs.location, NAF::POS, (yystack_[0].value.term)); }
#line 1214 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 102: // literal: "not" atom
#line 491 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                   { (yylhs.value.lit) = BUILDER.predlit(yylhs.location, NAF::NOT, (yystack_[0].value.term)); }
#line 1220 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 103: // literal: "not" "not" atom
#line 492 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                   { (yylhs.value.lit) = BUILDER.predlit(yylhs.location, NAF::NOTNOT, (yystack_[0].value.term)); }
#line 1226 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 104: // literal: term rellitvec
#line 493 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                   { (yylhs.value.lit) = BUILDER.rellit(yylhs.location, NAF::POS, (yystack_[1].value.term), (yystack_[0].value.rellitvec)); }
#line 1232 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 105: // literal: "not" term rellitvec
#line 494 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                   { (yylhs.value.lit) = BUILDER.rellit(yylhs.location, NAF::NOT, (yystack_[1].value.term), (yystack_[0].value.rellitvec)); }
#line 1238 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 106: // literal: "not" "not" term rellitvec
#line 495 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                   { (yylhs.value.lit) = BUILDER.rellit(yylhs.location, NAF::NOTNOT, (yystack_[1].value.term), (yystack_[0].value.rellitvec)); }
#line 1244 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 107: // nlitvec: literal
#line 503 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                      { (yylhs.value.litvec) = BUILDER.litvec(BUILDER.litvec(), (yystack_[0].value.lit)); }
#line 1250 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 108: // nlitvec: nlitvec "," literal
#line 504 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                      { (yylhs.value.litvec) = BUILDER.litvec((yystack_[2].value.litvec), (yystack_[0].value.lit)); }
#line 1256 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 109: // litvec: nlitvec
#line 508 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                   { (yylhs.value.litvec) = (yystack_[0].value.litvec); }
#line 1262 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 110: // litvec: %empty
#line 509 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                   { (yylhs.value.litvec) = BUILDER.litvec(); }
#line 1268 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 111: // optcondition: ":" litvec
#line 513 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                        { (yylhs.value.litvec) = (yystack_[0].value.litvec); }
#line 1274 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 112: // optcondition: %empty
#line 514 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                        { (yylhs.value.litvec) = BUILDER.litvec(); }
#line 1280 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 113: // aggregatefunction: "#sum"
#line 518 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
            { (yylhs.value.fun) = AggregateFunction::SUM; }
#line 1286 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 114: // aggregatefunction: "#sum+"
#line 519 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
            { (yylhs.value.fun) = AggregateFunction::SUMP; }
#line 1292 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 115: // aggregatefunction: "#min"
#line 520 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
            { (yylhs.value.fun) = AggregateFunction::MIN; }
#line 1298 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 116: // aggregatefunction: "#max"
#line 521 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
            { (yylhs.value.fun) = AggregateFunction::MAX; }
#line 1304 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 117: // aggregatefunction: "#count"
#line 522 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
            { (yylhs.value.fun) = AggregateFunction::COUNT; }
#line 1310 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 118: // bodyaggrelem: ":" litvec
#line 528 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                        { (yylhs.value.bodyaggrelem) = { BUILDER.termvec(), (yystack_[0].value.litvec) }; }
#line 1316 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 119: // bodyaggrelem: ntermvec optcondition
#line 529 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                        { (yylhs.value.bodyaggrelem) = { (yystack_[1].value.termvec), (yystack_[0].value.litvec) }; }
#line 1322 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 120: // bodyaggrelemvec: bodyaggrelem
#line 533 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                  { (yylhs.value.bodyaggrelemvec) = BUILDER.bodyaggrelemvec(BUILDER.bodyaggrelemvec(), (yystack_[0].value.bodyaggrelem).first, (yystack_[0].value.bodyaggrelem).second); }
#line 1328 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 121: // bodyaggrelemvec: bodyaggrelemvec ";" bodyaggrelem
#line 534 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                  { (yylhs.value.bodyaggrelemvec) = BUILDER.bodyaggrelemvec((yystack_[2].value.bodyaggrelemvec), (yystack_[0].value.bodyaggrelem).first, (yystack_[0].value.bodyaggrelem).second); }
#line 1334 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 122: // altbodyaggrelem: literal optcondition
#line 540 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                      { (yylhs.value.lbodyaggrelem) = { (yystack_[1].value.lit), (yystack_[0].value.litvec) }; }
#line 1340 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 123: // altbodyaggrelemvec: altbodyaggrelem
#line 544 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                        { (yylhs.value.condlitlist) = BUILDER.condlitvec(BUILDER.condlitvec(), (yystack_[0].value.lbodyaggrelem).first, (yystack_[0].value.lbodyaggrelem).second); }
#line 1346 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 124: // altbodyaggrelemvec: altbodyaggrelemvec ";" altbodyaggrelem
#line 545 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                        { (yylhs.value.condlitlist) = BUILDER.condlitvec((yystack_[2].value.condlitlist), (yystack_[0].value.lbodyaggrelem).first, (yystack_[0].value.lbodyaggrelem).second); }
#line 1352 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 125: // bodyaggregate: "{" "}"
#line 551 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                  { (yylhs.value.aggr) = { AggregateFunction::COUNT, true, BUILDER.condlitvec() }; }
#line 1358 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 126: // bodyaggregate: "{" altbodyaggrelemvec "}"
#line 552 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                  { (yylhs.value.aggr) = { AggregateFunction::COUNT, true, (yystack_[1].value.condlitlist) }; }
#line 1364 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 127: // bodyaggregate: aggregatefunction "{" "}"
#line 553 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                  { (yylhs.value.aggr) = { (yystack_[2].value.fun), false, BUILDER.bodyaggrelemvec() }; }
#line 1370 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 128: // bodyaggregate: aggregatefunction "{" bodyaggrelemvec "}"
#line 554 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                  { (yylhs.value.aggr) = { (yystack_[3].value.fun), false, (yystack_[1].value.bodyaggrelemvec) }; }
#line 1376 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 129: // upper: term
#line 558 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                       { (yylhs.value.bound) = { Relation::LEQ, (yystack_[0].value.term) }; }
#line 1382 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 130: // upper: cmp term
#line 559 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                       { (yylhs.value.bound) = { (yystack_[1].value.rel), (yystack_[0].value.term) }; }
#line 1388 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 131: // upper: %empty
#line 560 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                       { (yylhs.value.bound) = { Relation::LEQ, TermUid(-1) }; }
#line 1394 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 132: // lubodyaggregate: term bodyaggregate upper
#line 564 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                 { (yylhs.value.uid) = lexer->aggregate((yystack_[1].value.aggr).fun, (yystack_[1].value.aggr).choice, (yystack_[1].value.aggr).elems, lexer->boundvec(Relation::LEQ, (yystack_[2].value.term), (yystack_[0].value.bound).rel, (yystack_[0].value.bound).term)); }
#line 1400 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 133: // lubodyaggregate: term cmp bodyaggregate upper
#line 565 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                 { (yylhs.value.uid) = lexer->aggregate((yystack_[1].value.aggr).fun, (yystack_[1].value.aggr).choice, (yystack_[1].value.aggr).elems, lexer->boundvec((yystack_[2].value.rel), (yystack_[3].value.term), (yystack_[0].value.bound).rel, (yystack_[0].value.bound).term)); }
#line 1406 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 134: // lubodyaggregate: bodyaggregate upper
#line 566 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                 { (yylhs.value.uid) = lexer->aggregate((yystack_[1].value.aggr).fun, (yystack_[1].value.aggr).choice, (yystack_[1].value.aggr).elems, lexer->boundvec(Relation::LEQ, TermUid(-1), (yystack_[0].value.bound).rel, (yystack_[0].value.bound).term)); }
#line 1412 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 135: // lubodyaggregate: theory_atom
#line 567 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                 { (yylhs.value.uid) = lexer->aggregate((yystack_[0].value.theoryAtom)); }
#line 1418 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 136: // headaggrelemvec: headaggrelemvec ";" termvec ":" literal optcondition
#line 573 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                                     { (yylhs.value.headaggrelemvec) = BUILDER.headaggrelemvec((yystack_[5].value.headaggrelemvec), (yystack_[3].value.termvec), (yystack_[1].value.lit), (yystack_[0].value.litvec)); }
#line 1424 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 137: // headaggrelemvec: termvec ":" literal optcondition
#line 574 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                                     { (yylhs.value.headaggrelemvec) = BUILDER.headaggrelemvec(BUILDER.headaggrelemvec(), (yystack_[3].value.termvec), (yystack_[1].value.lit), (yystack_[0].value.litvec)); }
#line 1430 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 138: // altheadaggrelemvec: literal optcondition
#line 578 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                  { (yylhs.value.condlitlist) = BUILDER.condlitvec(BUILDER.condlitvec(), (yystack_[1].value.lit), (yystack_[0].value.litvec)); }
#line 1436 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 139: // altheadaggrelemvec: altheadaggrelemvec ";" literal optcondition
#line 579 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                  { (yylhs.value.condlitlist) = BUILDER.condlitvec((yystack_[3].value.condlitlist), (yystack_[1].value.lit), (yystack_[0].value.litvec)); }
#line 1442 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 140: // headaggregate: aggregatefunction "{" "}"
#line 585 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                  { (yylhs.value.aggr) = { (yystack_[2].value.fun), false, BUILDER.headaggrelemvec() }; }
#line 1448 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 141: // headaggregate: aggregatefunction "{" headaggrelemvec "}"
#line 586 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                  { (yylhs.value.aggr) = { (yystack_[3].value.fun), false, (yystack_[1].value.headaggrelemvec) }; }
#line 1454 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 142: // headaggregate: "{" "}"
#line 587 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                  { (yylhs.value.aggr) = { AggregateFunction::COUNT, true, BUILDER.condlitvec()}; }
#line 1460 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 143: // headaggregate: "{" altheadaggrelemvec "}"
#line 588 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                  { (yylhs.value.aggr) = { AggregateFunction::COUNT, true, (yystack_[1].value.condlitlist)}; }
#line 1466 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 144: // luheadaggregate: term headaggregate upper
#line 592 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                 { (yylhs.value.uid) = lexer->aggregate((yystack_[1].value.aggr).fun, (yystack_[1].value.aggr).choice, (yystack_[1].value.aggr).elems, lexer->boundvec(Relation::LEQ, (yystack_[2].value.term), (yystack_[0].value.bound).rel, (yystack_[0].value.bound).term)); }
#line 1472 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 145: // luheadaggregate: term cmp headaggregate upper
#line 593 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                 { (yylhs.value.uid) = lexer->aggregate((yystack_[1].value.aggr).fun, (yystack_[1].value.aggr).choice, (yystack_[1].value.aggr).elems, lexer->boundvec((yystack_[2].value.rel), (yystack_[3].value.term), (yystack_[0].value.bound).rel, (yystack_[0].value.bound).term)); }
#line 1478 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 146: // luheadaggregate: headaggregate upper
#line 594 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                 { (yylhs.value.uid) = lexer->aggregate((yystack_[1].value.aggr).fun, (yystack_[1].value.aggr).choice, (yystack_[1].value.aggr).elems, lexer->boundvec(Relation::LEQ, TermUid(-1), (yystack_[0].value.bound).rel, (yystack_[0].value.bound).term)); }
#line 1484 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 147: // luheadaggregate: theory_atom
#line 595 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                 { (yylhs.value.uid) = lexer->aggregate((yystack_[0].value.theoryAtom)); }
#line 1490 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 148: // conjunction: literal ":" litvec
#line 602 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                      { (yylhs.value.lbodyaggrelem) = { (yystack_[2].value.lit), (yystack_[0].value.litvec) }; }
#line 1496 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 151: // disjunctionsep: disjunctionsep literal ","
#line 616 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                { (yylhs.value.condlitlist) = BUILDER.condlitvec((yystack_[2].value.condlitlist), (yystack_[1].value.lit), BUILDER.litvec()); }
#line 1502 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 152: // disjunctionsep: disjunctionsep literal dsym
#line 617 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                { (yylhs.value.condlitlist) = BUILDER.condlitvec((yystack_[2].value.condlitlist), (yystack_[1].value.lit), BUILDER.litvec()); }
#line 1508 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 153: // disjunctionsep: disjunctionsep literal ":" ";"
#line 618 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                { (yylhs.value.condlitlist) = BUILDER.condlitvec((yystack_[3].value.condlitlist), (yystack_[2].value.lit), BUILDER.litvec()); }
#line 1514 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 154: // disjunctionsep: disjunctionsep literal ":" nlitvec dsym
#line 619 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                { (yylhs.value.condlitlist) = BUILDER.condlitvec((yystack_[4].value.condlitlist), (yystack_[3].value.lit), (yystack_[1].value.litvec)); }
#line 1520 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 155: // disjunctionsep: literal ","
#line 620 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                { (yylhs.value.condlitlist) = BUILDER.condlitvec(BUILDER.condlitvec(), (yystack_[1].value.lit), BUILDER.litvec()); }
#line 1526 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 156: // disjunctionsep: literal dsym
#line 621 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                { (yylhs.value.condlitlist) = BUILDER.condlitvec(BUILDER.condlitvec(), (yystack_[1].value.lit), BUILDER.litvec()); }
#line 1532 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 157: // disjunctionsep: literal ":" nlitvec dsym
#line 622 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                { (yylhs.value.condlitlist) = BUILDER.condlitvec(BUILDER.condlitvec(), (yystack_[3].value.lit), (yystack_[1].value.litvec)); }
#line 1538 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 158: // disjunctionsep: literal ":" ";"
#line 623 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                { (yylhs.value.condlitlist) = BUILDER.condlitvec(BUILDER.condlitvec(), (yystack_[2].value.lit), BUILDER.litvec()); }
#line 1544 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 159: // disjunction: disjunctionsep literal optcondition
#line 627 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                          { (yylhs.value.condlitlist) = BUILDER.condlitvec((yystack_[2].value.condlitlist), (yystack_[1].value.lit), (yystack_[0].value.litvec)); }
#line 1550 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 160: // disjunction: literal ":" litvec
#line 628 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                          { (yylhs.value.condlitlist) = BUILDER.condlitvec(BUILDER.condlitvec(), (yystack_[2].value.lit), (yystack_[0].value.litvec)); }
#line 1556 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 161: // bodycomma: bodycomma literal ","
#line 635 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                              { (yylhs.value.body) = BUILDER.bodylit((yystack_[2].value.body), (yystack_[1].value.lit)); }
#line 1562 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 162: // bodycomma: bodycomma literal ";"
#line 636 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                              { (yylhs.value.body) = BUILDER.bodylit((yystack_[2].value.body), (yystack_[1].value.lit)); }
#line 1568 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 163: // bodycomma: bodycomma lubodyaggregate ","
#line 637 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                              { (yylhs.value.body) = lexer->bodyaggregate((yystack_[2].value.body), yystack_[1].location, NAF::POS, (yystack_[1].value.uid)); }
#line 1574 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 164: // bodycomma: bodycomma lubodyaggregate ";"
#line 638 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                              { (yylhs.value.body) = lexer->bodyaggregate((yystack_[2].value.body), yystack_[1].location, NAF::POS, (yystack_[1].value.uid)); }
#line 1580 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 165: // bodycomma: bodycomma "not" lubodyaggregate ","
#line 639 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                              { (yylhs.value.body) = lexer->bodyaggregate((yystack_[3].value.body), yystack_[1].location + yystack_[2].location, NAF::NOT, (yystack_[1].value.uid)); }
#line 1586 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 166: // bodycomma: bodycomma "not" lubodyaggregate ";"
#line 640 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                              { (yylhs.value.body) = lexer->bodyaggregate((yystack_[3].value.body), yystack_[1].location + yystack_[2].location, NAF::NOT, (yystack_[1].value.uid)); }
#line 1592 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 167: // bodycomma: bodycomma "not" "not" lubodyaggregate ","
#line 641 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                              { (yylhs.value.body) = lexer->bodyaggregate((yystack_[4].value.body), yystack_[1].location + yystack_[3].location, NAF::NOTNOT, (yystack_[1].value.uid)); }
#line 1598 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 168: // bodycomma: bodycomma "not" "not" lubodyaggregate ";"
#line 642 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                              { (yylhs.value.body) = lexer->bodyaggregate((yystack_[4].value.body), yystack_[1].location + yystack_[3].location, NAF::NOTNOT, (yystack_[1].value.uid)); }
#line 1604 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 169: // bodycomma: bodycomma conjunction ";"
#line 643 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                              { (yylhs.value.body) = BUILDER.conjunction((yystack_[2].value.body), yystack_[1].location, (yystack_[1].value.lbodyaggrelem).first, (yystack_[1].value.lbodyaggrelem).second); }
#line 1610 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 170: // bodycomma: %empty
#line 644 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                              { (yylhs.value.body) = BUILDER.body(); }
#line 1616 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 171: // bodydot: bodycomma literal "."
#line 648 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                            { (yylhs.value.body) = BUILDER.bodylit((yystack_[2].value.body), (yystack_[1].value.lit)); }
#line 1622 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 172: // bodydot: bodycomma lubodyaggregate "."
#line 649 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                            { (yylhs.value.body) = lexer->bodyaggregate((yystack_[2].value.body), yystack_[1].location, NAF::POS, (yystack_[1].value.uid)); }
#line 1628 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 173: // bodydot: bodycomma "not" lubodyaggregate "."
#line 650 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                            { (yylhs.value.body) = lexer->bodyaggregate((yystack_[3].value.body), yystack_[1].location + yystack_[2].location, NAF::NOT, (yystack_[1].value.uid)); }
#line 1634 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 174: // bodydot: bodycomma "not" "not" lubodyaggregate "."
#line 651 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                            { (yylhs.value.body) = lexer->bodyaggregate((yystack_[4].value.body), yystack_[1].location + yystack_[3].location, NAF::NOTNOT, (yystack_[1].value.uid)); }
#line 1640 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 175: // bodydot: bodycomma conjunction "."
#line 652 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                            { (yylhs.value.body) = BUILDER.conjunction((yystack_[2].value.body), yystack_[1].location, (yystack_[1].value.lbodyaggrelem).first, (yystack_[1].value.lbodyaggrelem).second); }
#line 1646 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 176: // bodyconddot: "."
#line 656 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                      { (yylhs.value.body) = BUILDER.body(); }
#line 1652 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 177: // bodyconddot: ":" "."
#line 657 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                      { (yylhs.value.body) = BUILDER.body(); }
#line 1658 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 178: // bodyconddot: ":" bodydot
#line 658 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                            { (yylhs.value.body) = (yystack_[0].value.body); }
#line 1664 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 179: // head: literal
#line 661 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                              { (yylhs.value.head) = BUILDER.headlit((yystack_[0].value.lit)); }
#line 1670 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 180: // head: disjunction
#line 662 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                              { (yylhs.value.head) = BUILDER.disjunction(yylhs.location, (yystack_[0].value.condlitlist)); }
#line 1676 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 181: // head: luheadaggregate
#line 663 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                              { (yylhs.value.head) = lexer->headaggregate(yylhs.location, (yystack_[0].value.uid)); }
#line 1682 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 182: // statement: head "."
#line 667 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                              { BUILDER.rule(yylhs.location, (yystack_[1].value.head)); }
#line 1688 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 183: // statement: head ":-" "."
#line 668 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                              { BUILDER.rule(yylhs.location, (yystack_[2].value.head)); }
#line 1694 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 184: // statement: head ":-" bodydot
#line 669 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                              { BUILDER.rule(yylhs.location, (yystack_[2].value.head), (yystack_[0].value.body)); }
#line 1700 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 185: // statement: ":-" bodydot
#line 670 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                              { BUILDER.rule(yylhs.location, BUILDER.headlit(BUILDER.boollit(yylhs.location, false)), (yystack_[0].value.body)); }
#line 1706 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 186: // statement: ":-" "."
#line 671 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                              { BUILDER.rule(yylhs.location, BUILDER.headlit(BUILDER.boollit(yylhs.location, false)), BUILDER.body()); }
#line 1712 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 187: // optimizetuple: "," ntermvec
#line 677 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                          { (yylhs.value.termvec) = (yystack_[0].value.termvec); }
#line 1718 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 188: // optimizetuple: %empty
#line 678 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                          { (yylhs.value.termvec) = BUILDER.termvec(); }
#line 1724 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 189: // optimizeweight: term "@" term
#line 682 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                         { (yylhs.value.termpair) = {(yystack_[2].value.term), (yystack_[0].value.term)}; }
#line 1730 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 190: // optimizeweight: term
#line 683 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                         { (yylhs.value.termpair) = {(yystack_[0].value.term), BUILDER.term(yylhs.location, Symbol::createNum(0))}; }
#line 1736 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 191: // optimizelitvec: literal
#line 687 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                            { (yylhs.value.body) = BUILDER.bodylit(BUILDER.body(), (yystack_[0].value.lit)); }
#line 1742 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 192: // optimizelitvec: optimizelitvec "," literal
#line 688 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                            { (yylhs.value.body) = BUILDER.bodylit((yystack_[2].value.body), (yystack_[0].value.lit)); }
#line 1748 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 193: // optimizecond: ":" optimizelitvec
#line 692 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                               { (yylhs.value.body) = (yystack_[0].value.body); }
#line 1754 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 194: // optimizecond: ":"
#line 693 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                               { (yylhs.value.body) = BUILDER.body(); }
#line 1760 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 195: // optimizecond: %empty
#line 694 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                               { (yylhs.value.body) = BUILDER.body(); }
#line 1766 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 196: // statement: ":~" bodydot "[" optimizeweight optimizetuple "]"
#line 698 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                       { BUILDER.optimize(yylhs.location, (yystack_[2].value.termpair).first, (yystack_[2].value.termpair).second, (yystack_[1].value.termvec), (yystack_[4].value.body)); }
#line 1772 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 197: // statement: ":~" "." "[" optimizeweight optimizetuple "]"
#line 699 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                       { BUILDER.optimize(yylhs.location, (yystack_[2].value.termpair).first, (yystack_[2].value.termpair).second, (yystack_[1].value.termvec), BUILDER.body()); }
#line 1778 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 198: // maxelemlist: optimizeweight optimizetuple optimizecond
#line 703 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                          { BUILDER.optimize(yylhs.location, BUILDER.term(yystack_[2].location, UnOp::NEG, (yystack_[2].value.termpair).first), (yystack_[2].value.termpair).second, (yystack_[1].value.termvec), (yystack_[0].value.body)); }
#line 1784 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 199: // maxelemlist: maxelemlist ";" optimizeweight optimizetuple optimizecond
#line 704 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                          { BUILDER.optimize(yylhs.location, BUILDER.term(yystack_[2].location, UnOp::NEG, (yystack_[2].value.termpair).first), (yystack_[2].value.termpair).second, (yystack_[1].value.termvec), (yystack_[0].value.body)); }
#line 1790 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 200: // minelemlist: optimizeweight optimizetuple optimizecond
#line 708 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                          { BUILDER.optimize(yylhs.location, (yystack_[2].value.termpair).first, (yystack_[2].value.termpair).second, (yystack_[1].value.termvec), (yystack_[0].value.body)); }
#line 1796 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 201: // minelemlist: minelemlist ";" optimizeweight optimizetuple optimizecond
#line 709 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                          { BUILDER.optimize(yylhs.location, (yystack_[2].value.termpair).first, (yystack_[2].value.termpair).second, (yystack_[1].value.termvec), (yystack_[0].value.body)); }
#line 1802 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 206: // statement: "#showsig" identifier "/" "<NUMBER>" "."
#line 722 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { BUILDER.showsig(yylhs.location, Sig(String::fromRep((yystack_[3].value.str)), (yystack_[1].value.num), false)); }
#line 1808 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 207: // statement: "#showsig" "-" identifier "/" "<NUMBER>" "."
#line 723 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { BUILDER.showsig(yylhs.location, Sig(String::fromRep((yystack_[3].value.str)), (yystack_[1].value.num), true)); }
#line 1814 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 208: // statement: "#show" "."
#line 724 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { BUILDER.showsig(yylhs.location, Sig("", 0, false)); }
#line 1820 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 209: // statement: "#show" term ":" bodydot
#line 725 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { BUILDER.show(yylhs.location, (yystack_[2].value.term), (yystack_[0].value.body)); }
#line 1826 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 210: // statement: "#show" term "."
#line 726 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { BUILDER.show(yylhs.location, (yystack_[1].value.term), BUILDER.body()); }
#line 1832 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 211: // statement: "#defined" identifier "/" "<NUMBER>" "."
#line 732 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { BUILDER.defined(yylhs.location, Sig(String::fromRep((yystack_[3].value.str)), (yystack_[1].value.num), false)); }
#line 1838 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 212: // statement: "#defined" "-" identifier "/" "<NUMBER>" "."
#line 733 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { BUILDER.defined(yylhs.location, Sig(String::fromRep((yystack_[3].value.str)), (yystack_[1].value.num), true)); }
#line 1844 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 213: // statement: "#edge" "(" binaryargvec ")" bodyconddot
#line 738 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                              { BUILDER.edge(yylhs.location, (yystack_[2].value.termvecvec), (yystack_[0].value.body)); }
#line 1850 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 214: // statement: "#heuristic" atom bodyconddot "[" term "@" term "," term "]"
#line 744 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                                           { BUILDER.heuristic(yylhs.location, (yystack_[8].value.term), (yystack_[7].value.body), (yystack_[5].value.term), (yystack_[3].value.term), (yystack_[1].value.term)); }
#line 1856 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 215: // statement: "#heuristic" atom bodyconddot "[" term "," term "]"
#line 745 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                                           { BUILDER.heuristic(yylhs.location, (yystack_[6].value.term), (yystack_[5].value.body), (yystack_[3].value.term), BUILDER.term(yylhs.location, Symbol::createNum(0)), (yystack_[1].value.term)); }
#line 1862 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 216: // statement: "#project" identifier "/" "<NUMBER>" "."
#line 751 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                           { BUILDER.project(yylhs.location, Sig(String::fromRep((yystack_[3].value.str)), (yystack_[1].value.num), false)); }
#line 1868 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 217: // statement: "#project" "-" identifier "/" "<NUMBER>" "."
#line 752 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                           { BUILDER.project(yylhs.location, Sig(String::fromRep((yystack_[3].value.str)), (yystack_[1].value.num), true)); }
#line 1874 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 218: // statement: "#project" atom bodyconddot
#line 753 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                           { BUILDER.project(yylhs.location, (yystack_[1].value.term), (yystack_[0].value.body)); }
#line 1880 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 219: // define: identifier "=" constterm
#line 759 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                        {  BUILDER.define(yylhs.location, String::fromRep((yystack_[2].value.str)), (yystack_[0].value.term), false, LOGGER); }
#line 1886 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 220: // storecomment: %empty
#line 763 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
               { lexer->storeComments(); }
#line 1892 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 221: // statement: "#const" identifier "=" constterm "." storecomment
#line 766 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                               { BUILDER.define(yylhs.location, String::fromRep((yystack_[4].value.str)), (yystack_[2].value.term), true, LOGGER); lexer->flushComments(); }
#line 1898 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 222: // statement: "#const" identifier "=" constterm "." storecomment "[" "default" "]"
#line 767 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                                      { lexer->flushComments(); BUILDER.define(yylhs.location, String::fromRep((yystack_[7].value.str)), (yystack_[5].value.term), true, LOGGER); }
#line 1904 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 223: // statement: "#const" identifier "=" constterm "." storecomment "[" "override" "]"
#line 768 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                                      { lexer->flushComments(); BUILDER.define(yylhs.location, String::fromRep((yystack_[7].value.str)), (yystack_[5].value.term), false, LOGGER); }
#line 1910 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 224: // statement: "<SCRIPT>" "(" "<IDENTIFIER>" ")" "<CODE>" "."
#line 774 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                           { BUILDER.script(yylhs.location, String::fromRep((yystack_[3].value.str)), String::fromRep((yystack_[1].value.str))); }
#line 1916 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 225: // statement: "#include" "<STRING>" "."
#line 780 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                         { lexer->include(String::fromRep((yystack_[1].value.str)), yylhs.location, false, LOGGER); }
#line 1922 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 226: // statement: "#include" "<" identifier ">" "."
#line 781 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                         { lexer->include(String::fromRep((yystack_[2].value.str)), yylhs.location, true, LOGGER); }
#line 1928 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 227: // nidlist: nidlist "," identifier
#line 787 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                         { (yylhs.value.idlist) = BUILDER.idvec((yystack_[2].value.idlist), yystack_[0].location, String::fromRep((yystack_[0].value.str))); }
#line 1934 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 228: // nidlist: identifier
#line 788 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                         { (yylhs.value.idlist) = BUILDER.idvec(BUILDER.idvec(), yystack_[0].location, String::fromRep((yystack_[0].value.str))); }
#line 1940 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 229: // idlist: %empty
#line 792 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                    { (yylhs.value.idlist) = BUILDER.idvec(); }
#line 1946 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 230: // idlist: nidlist
#line 793 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                    { (yylhs.value.idlist) = (yystack_[0].value.idlist); }
#line 1952 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 231: // statement: "#program" identifier "(" idlist ")" "."
#line 797 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                            { BUILDER.block(yylhs.location, String::fromRep((yystack_[4].value.str)), (yystack_[2].value.idlist)); }
#line 1958 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 232: // statement: "#program" identifier "."
#line 798 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                            { BUILDER.block(yylhs.location, String::fromRep((yystack_[1].value.str)), BUILDER.idvec()); }
#line 1964 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 233: // statement: "#external" atom ":" bodydot storecomment
#line 804 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { BUILDER.external(yylhs.location, (yystack_[3].value.term), (yystack_[1].value.body), BUILDER.term(yylhs.location, Symbol::createId("false"))); lexer->flushComments(); }
#line 1970 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 234: // statement: "#external" atom ":" "." storecomment
#line 805 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { BUILDER.external(yylhs.location, (yystack_[3].value.term), BUILDER.body(), BUILDER.term(yylhs.location, Symbol::createId("false"))); lexer->flushComments(); }
#line 1976 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 235: // statement: "#external" atom "." storecomment
#line 806 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                       { BUILDER.external(yylhs.location, (yystack_[2].value.term), BUILDER.body(), BUILDER.term(yylhs.location, Symbol::createId("false"))); lexer->flushComments(); }
#line 1982 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 236: // statement: "#external" atom ":" bodydot storecomment "[" term "]"
#line 807 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                             { lexer->flushComments(); BUILDER.external(yylhs.location, (yystack_[6].value.term), (yystack_[4].value.body), (yystack_[1].value.term)); }
#line 1988 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 237: // statement: "#external" atom ":" "." storecomment "[" term "]"
#line 808 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                             { lexer->flushComments(); BUILDER.external(yylhs.location, (yystack_[6].value.term), BUILDER.body(), (yystack_[1].value.term)); }
#line 1994 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 238: // statement: "#external" atom "." storecomment "[" term "]"
#line 809 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                             { lexer->flushComments(); BUILDER.external(yylhs.location, (yystack_[5].value.term), BUILDER.body(), (yystack_[1].value.term)); }
#line 2000 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 239: // theory_op: "<THEORYOP>"
#line 815 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                     { (yylhs.value.str) = (yystack_[0].value.str); }
#line 2006 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 240: // theory_op: "not"
#line 816 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                     { (yylhs.value.str) = (yystack_[0].value.str); }
#line 2012 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 241: // theory_op_list: theory_op_list theory_op
#line 822 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                        { (yylhs.value.theoryOps) = BUILDER.theoryops((yystack_[1].value.theoryOps), String::fromRep((yystack_[0].value.str))); }
#line 2018 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 242: // theory_op_list: theory_op
#line 823 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                        { (yylhs.value.theoryOps) = BUILDER.theoryops(BUILDER.theoryops(), String::fromRep((yystack_[0].value.str))); }
#line 2024 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 243: // theory_term: "{" theory_opterm_list "}"
#line 827 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                          { (yylhs.value.theoryTerm) = BUILDER.theorytermset(yylhs.location, (yystack_[1].value.theoryOpterms)); }
#line 2030 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 244: // theory_term: "[" theory_opterm_list "]"
#line 828 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                          { (yylhs.value.theoryTerm) = BUILDER.theoryoptermlist(yylhs.location, (yystack_[1].value.theoryOpterms)); }
#line 2036 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 245: // theory_term: "(" ")"
#line 829 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                          { (yylhs.value.theoryTerm) = BUILDER.theorytermtuple(yylhs.location, BUILDER.theoryopterms()); }
#line 2042 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 246: // theory_term: "(" theory_opterm ")"
#line 830 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                          { (yylhs.value.theoryTerm) = BUILDER.theorytermopterm(yylhs.location, (yystack_[1].value.theoryOpterm)); }
#line 2048 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 247: // theory_term: "(" theory_opterm "," ")"
#line 831 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                          { (yylhs.value.theoryTerm) = BUILDER.theorytermtuple(yylhs.location, BUILDER.theoryopterms(BUILDER.theoryopterms(), yystack_[2].location, (yystack_[2].value.theoryOpterm))); }
#line 2054 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 248: // theory_term: "(" theory_opterm "," theory_opterm_nlist ")"
#line 832 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                          { (yylhs.value.theoryTerm) = BUILDER.theorytermtuple(yylhs.location, BUILDER.theoryopterms(yystack_[3].location, (yystack_[3].value.theoryOpterm), (yystack_[1].value.theoryOpterms))); }
#line 2060 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 249: // theory_term: identifier "(" theory_opterm_list ")"
#line 833 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                          { (yylhs.value.theoryTerm) = BUILDER.theorytermfun(yylhs.location, String::fromRep((yystack_[3].value.str)), (yystack_[1].value.theoryOpterms)); }
#line 2066 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 250: // theory_term: identifier
#line 834 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                          { (yylhs.value.theoryTerm) = BUILDER.theorytermvalue(yylhs.location, Symbol::createId(String::fromRep((yystack_[0].value.str)))); }
#line 2072 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 251: // theory_term: "<NUMBER>"
#line 835 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                          { (yylhs.value.theoryTerm) = BUILDER.theorytermvalue(yylhs.location, Symbol::createNum((yystack_[0].value.num))); }
#line 2078 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 252: // theory_term: "<STRING>"
#line 836 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                          { (yylhs.value.theoryTerm) = BUILDER.theorytermvalue(yylhs.location, Symbol::createStr(String::fromRep((yystack_[0].value.str)))); }
#line 2084 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 253: // theory_term: "#inf"
#line 837 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                          { (yylhs.value.theoryTerm) = BUILDER.theorytermvalue(yylhs.location, Symbol::createInf()); }
#line 2090 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 254: // theory_term: "#sup"
#line 838 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                          { (yylhs.value.theoryTerm) = BUILDER.theorytermvalue(yylhs.location, Symbol::createSup()); }
#line 2096 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 255: // theory_term: "<VARIABLE>"
#line 839 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                          { (yylhs.value.theoryTerm) = BUILDER.theorytermvar(yylhs.location, String::fromRep((yystack_[0].value.str))); }
#line 2102 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 256: // theory_opterm: theory_opterm theory_op_list theory_term
#line 843 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                  { (yylhs.value.theoryOpterm) = BUILDER.theoryopterm((yystack_[2].value.theoryOpterm), (yystack_[1].value.theoryOps), (yystack_[0].value.theoryTerm)); }
#line 2108 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 257: // theory_opterm: theory_op_list theory_term
#line 844 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                  { (yylhs.value.theoryOpterm) = BUILDER.theoryopterm((yystack_[1].value.theoryOps), (yystack_[0].value.theoryTerm)); }
#line 2114 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 258: // theory_opterm: theory_term
#line 845 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                  { (yylhs.value.theoryOpterm) = BUILDER.theoryopterm(BUILDER.theoryops(), (yystack_[0].value.theoryTerm)); }
#line 2120 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 259: // theory_opterm_nlist: theory_opterm_nlist "," theory_opterm
#line 849 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                            { (yylhs.value.theoryOpterms) = BUILDER.theoryopterms((yystack_[2].value.theoryOpterms), yystack_[0].location, (yystack_[0].value.theoryOpterm)); }
#line 2126 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 260: // theory_opterm_nlist: theory_opterm
#line 850 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                            { (yylhs.value.theoryOpterms) = BUILDER.theoryopterms(BUILDER.theoryopterms(), yystack_[0].location, (yystack_[0].value.theoryOpterm)); }
#line 2132 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 261: // theory_opterm_list: theory_opterm_nlist
#line 854 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                { (yylhs.value.theoryOpterms) = (yystack_[0].value.theoryOpterms); }
#line 2138 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 262: // theory_opterm_list: %empty
#line 855 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                { (yylhs.value.theoryOpterms) = BUILDER.theoryopterms(); }
#line 2144 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 263: // theory_atom_element: theory_opterm_nlist disable_theory_lexing optcondition
#line 859 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                         { (yylhs.value.theoryElem) = { (yystack_[2].value.theoryOpterms), (yystack_[0].value.litvec) }; }
#line 2150 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 264: // theory_atom_element: disable_theory_lexing ":" litvec
#line 860 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                         { (yylhs.value.theoryElem) = { BUILDER.theoryopterms(), (yystack_[0].value.litvec) }; }
#line 2156 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 265: // theory_atom_element_nlist: theory_atom_element_nlist enable_theory_lexing ";" theory_atom_element
#line 864 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                                         { (yylhs.value.theoryElems) = BUILDER.theoryelems((yystack_[3].value.theoryElems), (yystack_[0].value.theoryElem).first, (yystack_[0].value.theoryElem).second); }
#line 2162 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 266: // theory_atom_element_nlist: theory_atom_element
#line 865 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                                         { (yylhs.value.theoryElems) = BUILDER.theoryelems(BUILDER.theoryelems(), (yystack_[0].value.theoryElem).first, (yystack_[0].value.theoryElem).second); }
#line 2168 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 267: // theory_atom_element_list: theory_atom_element_nlist
#line 869 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                      { (yylhs.value.theoryElems) = (yystack_[0].value.theoryElems); }
#line 2174 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 268: // theory_atom_element_list: %empty
#line 870 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                      { (yylhs.value.theoryElems) = BUILDER.theoryelems(); }
#line 2180 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 269: // theory_atom_name: identifier
#line 874 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                      { (yylhs.value.term) = BUILDER.term(yylhs.location, String::fromRep((yystack_[0].value.str)), BUILDER.termvecvec(BUILDER.termvecvec(), BUILDER.termvec()), false); }
#line 2186 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 270: // theory_atom_name: identifier "(" argvec ")"
#line 875 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                      { (yylhs.value.term) = BUILDER.term(yylhs.location, String::fromRep((yystack_[3].value.str)), (yystack_[1].value.termvecvec), false); }
#line 2192 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 271: // theory_atom: "&" theory_atom_name
#line 878 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                 { (yylhs.value.theoryAtom) = BUILDER.theoryatom((yystack_[0].value.term), BUILDER.theoryelems()); }
#line 2198 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 272: // theory_atom: "&" theory_atom_name enable_theory_lexing "{" theory_atom_element_list enable_theory_lexing "}" disable_theory_lexing
#line 879 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                                                                                                                                   { (yylhs.value.theoryAtom) = BUILDER.theoryatom((yystack_[6].value.term), (yystack_[3].value.theoryElems)); }
#line 2204 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 273: // theory_atom: "&" theory_atom_name enable_theory_lexing "{" theory_atom_element_list enable_theory_lexing "}" theory_op theory_opterm disable_theory_lexing
#line 880 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                                                                                                                                   { (yylhs.value.theoryAtom) = BUILDER.theoryatom((yystack_[8].value.term), (yystack_[5].value.theoryElems), String::fromRep((yystack_[2].value.str)), yystack_[1].location, (yystack_[1].value.theoryOpterm)); }
#line 2210 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 274: // theory_operator_nlist: theory_op
#line 886 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                     { (yylhs.value.theoryOps) = BUILDER.theoryops(BUILDER.theoryops(), String::fromRep((yystack_[0].value.str))); }
#line 2216 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 275: // theory_operator_nlist: theory_operator_nlist "," theory_op
#line 887 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                     { (yylhs.value.theoryOps) = BUILDER.theoryops((yystack_[2].value.theoryOps), String::fromRep((yystack_[0].value.str))); }
#line 2222 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 276: // theory_operator_list: theory_operator_nlist
#line 891 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                 { (yylhs.value.theoryOps) = (yystack_[0].value.theoryOps); }
#line 2228 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 277: // theory_operator_list: %empty
#line 892 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                 { (yylhs.value.theoryOps) = BUILDER.theoryops(); }
#line 2234 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 278: // theory_operator_definition: theory_op enable_theory_definition_lexing ":" "<NUMBER>" "," "unary"
#line 896 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                                                 { (yylhs.value.theoryOpDef) = BUILDER.theoryopdef(yylhs.location, String::fromRep((yystack_[5].value.str)), (yystack_[2].value.num), TheoryOperatorType::Unary); }
#line 2240 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 279: // theory_operator_definition: theory_op enable_theory_definition_lexing ":" "<NUMBER>" "," "binary" "," "left"
#line 897 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                                                 { (yylhs.value.theoryOpDef) = BUILDER.theoryopdef(yylhs.location, String::fromRep((yystack_[7].value.str)), (yystack_[4].value.num), TheoryOperatorType::BinaryLeft); }
#line 2246 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 280: // theory_operator_definition: theory_op enable_theory_definition_lexing ":" "<NUMBER>" "," "binary" "," "right"
#line 898 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                                                 { (yylhs.value.theoryOpDef) = BUILDER.theoryopdef(yylhs.location, String::fromRep((yystack_[7].value.str)), (yystack_[4].value.num), TheoryOperatorType::BinaryRight); }
#line 2252 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 281: // theory_operator_definition_nlist: theory_operator_definition
#line 902 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                                                      { (yylhs.value.theoryOpDefs) = BUILDER.theoryopdefs(BUILDER.theoryopdefs(), (yystack_[0].value.theoryOpDef)); }
#line 2258 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 282: // theory_operator_definition_nlist: theory_operator_definition_nlist enable_theory_lexing ";" theory_operator_definition
#line 903 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                                                      { (yylhs.value.theoryOpDefs) = BUILDER.theoryopdefs((yystack_[3].value.theoryOpDefs), (yystack_[0].value.theoryOpDef)); }
#line 2264 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 283: // theory_operator_definiton_list: theory_operator_definition_nlist
#line 907 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                             { (yylhs.value.theoryOpDefs) = (yystack_[0].value.theoryOpDefs); }
#line 2270 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 284: // theory_operator_definiton_list: %empty
#line 908 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                             { (yylhs.value.theoryOpDefs) = BUILDER.theoryopdefs(); }
#line 2276 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 285: // theory_definition_identifier: identifier
#line 912 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                     { (yylhs.value.str) = (yystack_[0].value.str); }
#line 2282 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 286: // theory_definition_identifier: "left"
#line 913 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                     { (yylhs.value.str) = String::toRep("left"); }
#line 2288 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 287: // theory_definition_identifier: "right"
#line 914 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                     { (yylhs.value.str) = String::toRep("right"); }
#line 2294 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 288: // theory_definition_identifier: "unary"
#line 915 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                     { (yylhs.value.str) = String::toRep("unary"); }
#line 2300 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 289: // theory_definition_identifier: "binary"
#line 916 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                     { (yylhs.value.str) = String::toRep("binary"); }
#line 2306 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 290: // theory_definition_identifier: "head"
#line 917 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                     { (yylhs.value.str) = String::toRep("head"); }
#line 2312 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 291: // theory_definition_identifier: "body"
#line 918 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                     { (yylhs.value.str) = String::toRep("body"); }
#line 2318 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 292: // theory_definition_identifier: "any"
#line 919 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                     { (yylhs.value.str) = String::toRep("any"); }
#line 2324 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 293: // theory_definition_identifier: "directive"
#line 920 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                     { (yylhs.value.str) = String::toRep("directive"); }
#line 2330 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 294: // theory_term_definition: theory_definition_identifier enable_theory_lexing "{" theory_operator_definiton_list enable_theory_definition_lexing "}"
#line 924 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                                                                                                { (yylhs.value.theoryTermDef) = BUILDER.theorytermdef(yylhs.location, String::fromRep((yystack_[5].value.str)), (yystack_[2].value.theoryOpDefs), LOGGER); }
#line 2336 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 295: // theory_atom_type: "head"
#line 928 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                { (yylhs.value.theoryAtomType) = TheoryAtomType::Head; }
#line 2342 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 296: // theory_atom_type: "body"
#line 929 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                { (yylhs.value.theoryAtomType) = TheoryAtomType::Body; }
#line 2348 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 297: // theory_atom_type: "any"
#line 930 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                { (yylhs.value.theoryAtomType) = TheoryAtomType::Any; }
#line 2354 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 298: // theory_atom_type: "directive"
#line 931 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                { (yylhs.value.theoryAtomType) = TheoryAtomType::Directive; }
#line 2360 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 299: // theory_atom_definition: "&" theory_definition_identifier "/" "<NUMBER>" ":" theory_definition_identifier "," enable_theory_lexing "{" theory_operator_list enable_theory_definition_lexing "}" "," theory_definition_identifier "," theory_atom_type
#line 936 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                                                                                                                             { (yylhs.value.theoryAtomDef) = BUILDER.theoryatomdef(yylhs.location, String::fromRep((yystack_[14].value.str)), (yystack_[12].value.num), String::fromRep((yystack_[10].value.str)), (yystack_[0].value.theoryAtomType), (yystack_[6].value.theoryOps), String::fromRep((yystack_[2].value.str))); }
#line 2366 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 300: // theory_atom_definition: "&" theory_definition_identifier "/" "<NUMBER>" ":" theory_definition_identifier "," theory_atom_type
#line 937 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                                                                                                                             { (yylhs.value.theoryAtomDef) = BUILDER.theoryatomdef(yylhs.location, String::fromRep((yystack_[6].value.str)), (yystack_[4].value.num), String::fromRep((yystack_[2].value.str)), (yystack_[0].value.theoryAtomType)); }
#line 2372 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 301: // theory_definition_nlist: theory_definition_list ";" theory_atom_definition
#line 941 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                   { (yylhs.value.theoryDefs) = BUILDER.theorydefs((yystack_[2].value.theoryDefs), (yystack_[0].value.theoryAtomDef)); }
#line 2378 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 302: // theory_definition_nlist: theory_definition_list ";" theory_term_definition
#line 942 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                   { (yylhs.value.theoryDefs) = BUILDER.theorydefs((yystack_[2].value.theoryDefs), (yystack_[0].value.theoryTermDef)); }
#line 2384 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 303: // theory_definition_nlist: theory_atom_definition
#line 943 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                  { (yylhs.value.theoryDefs) = BUILDER.theorydefs(BUILDER.theorydefs(), (yystack_[0].value.theoryAtomDef)); }
#line 2390 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 304: // theory_definition_nlist: theory_term_definition
#line 944 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                  { (yylhs.value.theoryDefs) = BUILDER.theorydefs(BUILDER.theorydefs(), (yystack_[0].value.theoryTermDef)); }
#line 2396 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 305: // theory_definition_list: theory_definition_nlist
#line 948 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                    { (yylhs.value.theoryDefs) = (yystack_[0].value.theoryDefs); }
#line 2402 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 306: // theory_definition_list: %empty
#line 949 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                    { (yylhs.value.theoryDefs) = BUILDER.theorydefs(); }
#line 2408 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 307: // statement: "#theory" identifier enable_theory_definition_lexing "{" theory_definition_list "}" disable_theory_lexing "."
#line 953 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
                                                                                                                                   { BUILDER.theorydef(yylhs.location, String::fromRep((yystack_[6].value.str)), (yystack_[3].value.theoryDefs), LOGGER); }
#line 2414 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 308: // enable_theory_lexing: %empty
#line 959 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
      { lexer->theoryLexing(TheoryLexing::Theory); }
#line 2420 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 309: // enable_theory_definition_lexing: %empty
#line 963 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
      { lexer->theoryLexing(TheoryLexing::Definition); }
#line 2426 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;

  case 310: // disable_theory_lexing: %empty
#line 967 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
      { lexer->theoryLexing(TheoryLexing::Disabled); }
#line 2432 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"
    break;


#line 2436 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // parser::context.
  parser::context::context (const parser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  parser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    const int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        const int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        const int yychecklim = yylast_ - yyn + 1;
        const int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }






  int
  parser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  parser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short parser::yypact_ninf_ = -485;

  const short parser::yytable_ninf_ = -311;

  const short
  parser::yypact_[] =
  {
     108,  -485,   245,    64,   728,  -485,  -485,  -485,    94,    31,
    -485,  -485,   245,   245,  1374,   245,  -485,  -485,    33,   156,
    -485,    73,    15,  -485,   950,  1190,  -485,    97,  -485,   105,
    1227,   116,   160,    33,   225,  1374,  -485,  -485,  -485,  -485,
     245,  1374,    96,   245,  -485,  -485,  -485,   118,  -485,  -485,
    1081,  -485,   496,  1570,  -485,    82,   143,   807,  -485,  1092,
    -485,    46,  -485,  1411,  -485,    40,   148,   170,   153,  1374,
     157,  -485,   202,   245,   183,    37,   245,   182,  -485,   540,
    -485,   245,   222,  -485,  1648,   231,   144,  -485,  1851,   239,
     220,  1190,   235,  1269,  1283,  -485,  1222,  1374,   245,    42,
     119,   119,   245,   230,  1728,  -485,   106,  1851,    23,   263,
     273,  -485,   228,  -485,  -485,  1129,  1648,  -485,  1374,  1374,
    1374,  -485,  1374,  -485,  -485,  -485,  -485,  1374,  1374,  -485,
    1374,  1374,  1374,  1374,  1374,   867,   388,   807,   964,  -485,
    -485,  -485,  -485,  1321,  1851,  1374,  -485,    85,  -485,   299,
     245,  1411,  -485,   204,  1411,  -485,  1411,  -485,  -485,   304,
    1871,  -485,  -485,  1374,   297,  1374,  1374,  1411,   314,  1374,
     325,  -485,   296,   298,  1002,   625,  1611,   282,   342,   807,
     133,   103,  -485,   348,  -485,  1374,  1092,  -485,  -485,  1092,
    1374,  -485,   361,  -485,   376,  1675,   402,   152,   409,   402,
     164,  -485,  -485,  1684,   174,   107,   343,   422,  -485,  -485,
     411,   391,   379,  1374,  -485,   245,  1374,  -485,  1374,  1374,
     415,   400,  -485,  -485,  1648,  -485,   388,   443,  -485,   216,
     324,   539,  1909,   417,   417,   417,   281,   417,   324,   963,
    1851,   807,  1374,  -485,  -485,  -485,    62,  -485,  -485,   450,
     205,  1851,  1044,  -485,  -485,  -485,  -485,  -485,   432,  -485,
     421,  -485,  1871,    43,  -485,  1499,  1411,  1411,  1411,  1411,
    1411,  1411,  1411,  1411,  1411,  1411,   294,   642,   305,   311,
    1889,  1374,   335,  -485,  -485,   439,   394,   454,  -485,   231,
    -485,   262,   313,  1611,   187,   902,   807,  1092,  -485,  -485,
    -485,  1171,  -485,  -485,  -485,  -485,  -485,  -485,   455,   460,
    -485,   231,  1851,  -485,  -485,  1374,  1374,   462,   458,  1374,
    -485,   462,   461,  1374,  -485,  1374,   119,  1374,   401,   464,
    -485,  -485,  1374,   412,   473,   339,  -485,   478,   448,  1851,
     402,   402,   381,   413,   388,  1374,   585,  1374,  -485,  1851,
    1092,  -485,  1092,  -485,  1374,  -485,    62,  1411,  -485,  1426,
    -485,  -485,   483,   459,   363,  1509,   465,   465,   465,  1576,
     465,   363,  1282,  -485,  -485,   766,   766,  1446,  -485,  -485,
    -485,  -485,  -485,  -485,   475,  -485,   766,  -485,   302,   498,
    -485,   469,  -485,   503,  -485,  -485,  -485,   360,  -485,   488,
     489,  1374,   507,  -485,  -485,  -485,  1092,  1611,   292,  -485,
    -485,  -485,   807,  -485,  -485,  1092,  -485,   397,  -485,   272,
    -485,  -485,  1851,   443,  1092,  -485,  -485,   402,  -485,  -485,
     402,  1851,  -485,  1724,   509,  -485,  1373,   511,  -485,   815,
     245,   514,   477,   491,  1896,  -485,  -485,  -485,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,   284,   518,
    -485,  -485,   231,   527,  -485,   500,  -485,  1871,  1411,  -485,
     498,   506,   497,  -485,    45,   766,  -485,  -485,   766,   766,
     231,   505,   512,  1092,   529,  -485,  1374,  1374,  1742,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  1363,  -485,
     546,   462,   462,  1374,  -485,  1374,  1374,  -485,  -485,  -485,
    -485,  -485,   513,   532,  -485,   381,  -485,  -485,  1092,  -485,
    -485,  -485,  1489,  -485,   519,  -485,   302,  -485,   766,   302,
    -485,   347,  1760,  1784,  -485,  -485,  1092,  -485,  -485,  1851,
    1800,  1824,   490,   302,   548,  -485,  -485,   231,  -485,    56,
    -485,  -485,   766,  -485,   526,   535,  -485,  -485,  -485,  1374,
    -485,   558,  -485,  -485,   469,  -485,  -485,  -485,  -485,   302,
    -485,  -485,  1842,  1896,   560,   536,   542,  -485,  -485,   569,
     523,   302,  -485,   357,   574,  -485,  -485,  -485,  -485,  -485,
    -485,   561,   367,   302,  -485,   575,  -485,   588,  -485,   368,
     302,   562,  -485,  -485,  -485,   590,  1896,   592,   357,  -485
  };

  const short
  parser::yydefact_[] =
  {
       0,     5,     0,     0,     0,    10,    11,    12,     0,     0,
       1,   310,     0,     0,     0,     0,   117,     7,     0,     0,
      98,   170,     0,    61,     0,    74,   116,     0,   115,     0,
       0,     0,     0,     0,     0,     0,   113,   114,    62,    95,
       0,     0,   170,     0,     6,    59,    64,     0,    60,    63,
       0,     4,    57,     0,   101,   179,     0,   131,   181,     0,
     180,     0,   147,     0,     3,     0,   269,   271,    58,     0,
      57,    52,     0,     0,    89,     0,     0,     0,   186,     0,
     185,     0,     0,   142,     0,   112,     0,    73,    67,    72,
      77,    74,     0,     0,     0,   208,     0,     0,     0,    89,
       0,     0,     0,     0,    57,    51,     0,    65,     0,     0,
       0,   309,     0,    99,    96,     0,     0,   102,    70,     0,
       0,    87,     0,    85,    83,    86,    84,     0,     0,    88,
       0,     0,     0,     0,     0,     0,   104,   131,   110,   155,
     149,   150,   156,    70,   129,     0,   146,   112,   182,   170,
       0,     0,    35,     0,     0,    36,     0,    33,    34,    31,
     219,     8,     9,    70,     0,    70,    70,     0,    91,    70,
     170,   220,     0,     0,     0,     0,     0,     0,     0,   131,
       0,     0,   135,     0,   225,     0,   110,   138,   143,     0,
      71,    75,    78,    53,     0,   190,   188,     0,     0,   188,
       0,   170,   210,     0,     0,    91,     0,   170,   176,   218,
       0,     0,     0,    70,   232,   229,     0,    56,     0,     0,
       0,     0,   100,    97,     0,   103,   105,    69,    79,     0,
      45,    44,    41,    49,    47,    50,    43,    48,    46,    42,
      93,   131,     0,   144,   158,   107,   109,   160,   140,     0,
       0,   130,   110,   151,   159,   152,   183,   184,    32,    23,
       0,    24,    37,     0,    22,     0,    40,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   268,     0,     0,
       0,    70,     0,   220,   220,   235,     0,     0,   125,   112,
     123,     0,     0,     0,     0,     0,   131,   110,   161,   171,
     162,     0,   134,   163,   172,   164,   175,   169,     0,   109,
     111,   112,    68,    76,   203,     0,     0,   195,     0,     0,
     202,   195,     0,     0,   209,     0,     0,     0,     0,     0,
     177,   178,     0,     0,     0,     0,   228,   230,     0,    66,
     188,   188,   306,     0,   106,     0,    54,    70,   145,    94,
       0,   157,     0,   141,    70,   153,   109,    40,    25,     0,
      26,    30,    39,     0,    16,    15,    20,    18,    21,    14,
      19,    17,    13,   270,   253,   262,   262,     0,   254,   251,
     252,   255,   239,   240,   250,   242,     0,   258,   260,   310,
     266,   267,   308,     0,    55,    54,   220,     0,    90,   234,
     233,     0,     0,   211,   122,   126,     0,     0,     0,   165,
     173,   166,   131,   132,   148,   110,   127,   112,   120,     0,
     226,   139,   189,   187,   194,   198,   205,   188,   200,   204,
     188,    81,   213,     0,     0,   216,     0,     0,   206,    54,
       0,     0,     0,     0,     0,   292,   288,   289,   286,   287,
     290,   291,   293,   285,   308,   304,   303,   305,     0,     0,
      80,   108,   112,     0,   154,     0,    27,    38,     0,    28,
     261,     0,     0,   245,     0,   262,   241,   257,     0,     0,
     112,     0,     0,   110,   221,    92,     0,     0,     0,   212,
     124,   167,   174,   168,   133,   118,   119,   128,     0,   191,
     193,   195,   195,     0,   217,     0,     0,   207,   227,   231,
     197,   196,     0,     0,   310,     0,   224,   137,     0,    29,
     243,   244,     0,   246,     0,   256,   259,   263,   310,   310,
     264,     0,     0,     0,   238,   121,     0,   199,   201,    82,
       0,     0,     0,   284,     0,   302,   301,   112,   247,     0,
     249,   265,     0,   272,     0,     0,   237,   236,   192,     0,
     215,     0,   309,   281,   283,   309,   307,   136,   248,   310,
     222,   223,     0,     0,     0,     0,     0,   273,   214,     0,
       0,     0,   294,   308,     0,   282,   297,   295,   296,   298,
     300,     0,     0,   277,   278,     0,   274,   276,   309,     0,
       0,     0,   279,   280,   275,     0,     0,     0,     0,   299
  };

  const short
  parser::yypgoto_[] =
  {
    -485,  -485,  -485,  -485,    -2,   -49,   456,   246,   364,  -485,
     -18,  -120,   517,  -485,  -485,  -107,  -485,   -47,    17,  -113,
       4,   -86,  -134,  -129,    32,   112,  -485,   206,  -485,  -155,
    -132,  -135,  -485,  -485,   -14,  -485,  -485,  -123,  -485,  -485,
    -485,     1,   -89,  -485,  -179,   -60,  -485,  -302,  -485,  -485,
    -485,  -208,  -485,  -485,  -288,  -373,  -341,  -348,  -268,  -334,
      83,  -485,  -485,  -485,   612,  -485,  -485,    36,  -485,  -485,
    -417,   110,    12,   111,  -485,  -485,  -366,  -484,   -10
  };

  const short
  parser::yydefgoto_[] =
  {
       0,     3,     4,    51,    70,   262,   362,   363,    84,   108,
     227,   228,    90,    91,    92,   229,   204,   145,    54,   136,
     245,   309,   310,   187,   178,   418,   419,   290,   291,   179,
     146,   180,   250,    86,    57,    58,   181,   142,    59,    60,
      79,    80,   209,    61,   317,   196,   500,   425,   197,   200,
       9,   285,   337,   338,   385,   386,   387,   388,   470,   471,
     390,   391,   392,    67,   182,   597,   598,   563,   564,   565,
     454,   455,   590,   456,   457,   458,   164,   220,   393
  };

  const short
  parser::yytable_[] =
  {
       8,    65,    52,   226,   247,   243,   135,    89,    55,   389,
      66,    68,   210,    72,   160,   478,    74,    77,   254,   428,
     321,   296,    52,   249,   255,   481,   482,   512,    85,   474,
      99,    74,   103,   104,   199,    75,    56,   185,   106,   137,
     294,   111,   472,   110,    81,   477,   170,   302,    52,   100,
     101,   171,   246,   359,   161,   522,   276,    52,   278,   279,
     148,   159,   282,   147,    10,   216,   479,   117,   149,   185,
     169,   168,   350,    89,   172,   399,   400,    52,   574,   183,
     217,   576,    73,   177,   360,    56,   523,    78,   513,   242,
     206,   138,   139,    82,   252,   253,   205,   568,   476,    63,
     211,   478,   259,    64,   140,   264,   335,   265,     5,   348,
     109,   344,   162,    52,   601,     6,     7,   306,   280,   141,
     214,   241,    93,   351,   140,   382,   383,   140,   207,   295,
      94,   526,   225,   208,   215,   281,    52,   525,   296,   141,
     412,   524,   141,   303,    97,   307,   112,   304,   258,   159,
     257,   159,   159,   478,   159,   328,   579,   408,   340,   341,
     404,   442,   443,   414,   413,   159,   356,    56,   143,     1,
       2,   284,    52,    52,   397,   305,   163,   185,   289,   242,
     226,   165,   421,   188,    52,   166,   189,    52,   484,   607,
     476,   318,   117,   311,   319,  -308,   478,   409,   575,   537,
     538,   410,   324,   322,   569,    76,   323,   167,   331,    98,
     150,   169,   151,   336,   260,   326,   327,   591,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   460,   152,   411,
     173,     5,   153,   464,   463,     5,   184,   432,     6,     7,
     186,   552,     6,     7,   353,   261,   295,   354,   501,   190,
      52,   502,   296,   154,   549,   562,   155,   346,   347,   427,
     389,   156,   191,   430,   159,   159,   159,   159,   159,   159,
     159,   159,   159,   159,   102,   384,   193,   157,   212,     5,
     494,   495,   158,   417,   119,   120,     6,     7,   496,   218,
      52,   297,   298,   562,   344,    52,   299,   242,   423,   219,
       5,   405,   491,   221,   406,   596,   492,     6,     7,   225,
     467,   497,   604,   256,   498,   127,   128,    12,   130,    13,
       5,    14,   277,   514,   300,    16,   515,     6,     7,   132,
     133,   222,   266,   517,   493,   373,   347,    23,   174,   283,
     453,    25,   281,    26,   286,    28,   394,   347,    52,   530,
      52,   527,   395,   347,   461,   159,   462,   159,   127,   128,
     295,   130,    35,    36,    37,    38,   223,   301,    53,   308,
      41,   287,   132,   384,   384,   384,   398,   347,    71,   480,
     439,   347,   382,   383,   384,   444,    45,    46,     5,    88,
     314,    48,    49,   121,    96,     6,     7,   269,   270,   105,
     271,   485,   347,   313,    52,   107,   186,   345,   123,   124,
     289,   273,   316,    52,   116,   125,   329,   126,   567,   467,
     586,   144,    52,   320,   129,   587,   588,   589,   499,   554,
     555,   594,   595,   105,   602,   603,   330,   332,   508,   333,
     342,   343,   453,   176,   445,   446,   447,   448,   449,   450,
     451,   452,   334,   345,   130,    88,     5,   195,   195,   352,
     357,   203,   358,     6,     7,   401,   159,   402,   403,   420,
     350,   424,   426,   384,   434,   429,   384,   384,   435,   224,
     417,    52,    88,   230,   231,   437,   232,   438,   440,   441,
     459,   233,   234,   468,   235,   236,   237,   238,   239,   240,
     469,   144,   271,   475,   544,   -89,   -89,    88,   479,   251,
     -89,  -308,   483,   453,   486,   487,    52,   510,   -89,   553,
     384,   489,   547,   504,   118,   507,   384,    88,   509,    88,
      88,   511,   516,    88,    52,   -89,   518,   521,   -89,   293,
     558,   519,   119,   144,    12,   520,    13,   528,    14,   240,
     384,   529,    16,   -89,   312,   531,   536,   543,    20,   577,
     550,   542,   566,   561,    23,   174,   570,   573,    25,   580,
      26,   453,    28,   127,   128,   571,   130,    88,   581,   583,
     339,   582,   195,   195,   592,   599,   593,   132,   133,    35,
      36,    37,    38,    39,   -90,   -90,   584,    41,   600,   -90,
     606,   605,   608,   465,   453,   144,   349,   -90,   192,   263,
     535,   551,   490,    45,    46,     5,    62,   585,    48,    49,
     609,   175,     6,     7,   -90,   545,   546,   -90,     0,    12,
       0,    13,     0,    14,     0,     0,     0,    16,     0,     0,
       0,     0,   -90,   113,     0,    88,     0,     0,     0,    23,
     174,  -310,     0,    25,     0,    26,   407,    28,     0,   240,
     144,     0,     0,     0,     0,    88,   374,   375,   376,     0,
     377,     0,     0,     0,    35,    36,    37,    38,   114,   422,
      88,     0,    41,   195,     0,     0,     0,   195,     0,   431,
       0,   433,     0,     0,   378,     0,   436,     0,    45,    46,
       5,     0,     0,    48,    49,     0,   292,     6,     7,   312,
       0,    88,     0,     0,     0,   379,     0,     5,    88,     0,
     380,   381,   382,   383,     6,     7,     0,     0,    -2,    11,
       0,     0,    12,     0,    13,     0,    14,     0,     0,    15,
      16,     0,    17,     0,    18,    19,    20,     0,     0,     0,
      21,    22,    23,    24,     0,     0,    25,     0,    26,    27,
      28,    29,     0,     0,     0,   488,     0,     0,     0,     0,
       0,    30,    31,    32,    33,    34,   144,    35,    36,    37,
      38,    39,    40,     0,     0,    41,     0,    42,     0,     0,
     374,   375,   376,     0,   377,     0,     0,     0,     0,    43,
      44,    45,    46,     5,    47,     0,    48,    49,     0,    50,
       6,     7,   121,    13,     0,    14,     0,     0,   378,     0,
       0,     0,     0,     0,   -92,   -92,     0,   123,   124,   -92,
       0,    23,     0,     0,   125,    25,   126,   -92,     0,   379,
       0,     5,     0,   129,   380,   381,   382,   383,     6,     7,
     532,   533,     0,     0,   -92,     0,    69,   -92,     0,    38,
       0,     0,    88,     0,    41,     0,     0,   539,     0,   540,
     541,     0,   -92,    13,     0,    14,     0,     0,     0,    16,
      45,    46,     5,     0,     0,    48,    49,     0,     0,     6,
       7,    23,    24,     0,     0,    25,     0,    26,     0,    28,
       0,     0,     0,     0,     0,     0,     0,     0,    13,     0,
      14,     0,     0,     0,    16,     0,    69,    36,    37,    38,
       0,     0,     0,   572,    41,     0,    23,   174,     0,     0,
      25,     0,    26,     0,    28,     0,     0,     0,     0,     0,
      45,    46,     5,     0,     0,    48,    49,     0,     0,     6,
       7,    69,    36,    37,    38,     0,    13,     0,    14,    41,
       0,     0,     0,     0,     0,     0,   119,   120,    20,     0,
      13,     0,    14,     0,    23,    45,    46,     5,    25,     0,
      48,    49,    20,     0,     6,     7,     0,     0,    23,    83,
       0,     0,    25,     0,     0,     0,     0,   127,   128,    35,
     130,   131,    38,    39,     0,     0,   244,    41,    13,     0,
      14,   132,   133,    35,     0,     0,    38,    39,     0,     0,
      20,    41,     0,    45,    46,     5,    23,     0,    48,    49,
      25,    50,     6,     7,     0,     0,     0,    45,    46,     5,
       0,   288,    48,    49,     0,    50,     6,     7,     0,     0,
      13,    35,    14,     0,    38,    39,     0,     0,     0,    41,
       0,     0,    20,     0,     0,     0,     0,     0,    23,     0,
       0,     0,    25,     0,     0,    45,    46,     5,     0,     0,
      48,    49,     0,    50,     6,     7,   355,    13,     0,    14,
       0,     0,     0,    35,     0,     0,    38,    39,    13,   113,
      14,    41,     0,     0,     0,    23,     0,     0,     0,    25,
      20,     0,     0,     0,     0,     0,    23,    45,    46,     5,
      25,     0,    48,    49,     0,    50,     6,     7,     0,     0,
      35,     0,     0,    38,   114,    13,     0,    14,    41,     0,
       0,    35,     0,     0,    38,    39,     0,   222,     0,    41,
       0,     0,     0,    23,    45,    46,     5,    25,     0,    48,
      49,     0,   115,     6,     7,    45,    46,     5,     0,     0,
      48,    49,     0,    50,     6,     7,     0,    13,    35,    14,
     415,    38,   223,     0,     0,     0,    41,     0,     0,     0,
       0,     0,     0,     0,     0,    23,    13,     0,    14,    25,
      87,     0,    45,    46,     5,     0,     0,    48,    49,     0,
     416,     6,     7,     0,    23,     0,     0,     0,    25,     0,
      69,     0,     0,    38,     0,   119,   120,     0,    41,     0,
       0,   201,     0,    13,     0,    14,   202,   122,     0,    69,
       0,    95,    38,     0,    45,    46,     5,    41,     0,    48,
      49,    23,     0,     6,     7,    25,   127,   128,     0,   130,
     131,     0,     0,    45,    46,     5,     0,     0,    48,    49,
     132,   133,     6,     7,     0,    13,    69,    14,     0,    38,
       0,     0,   134,     0,    41,   267,   268,     0,     0,    13,
       0,    14,     0,    23,     0,     0,     0,    25,     0,     0,
      45,    46,     5,     0,     0,    48,    49,    23,   194,     6,
       7,    25,     0,     0,     0,     0,   269,   270,    69,   271,
     272,    38,   198,     0,     0,     0,    41,    13,     0,    14,
     273,   274,    69,     0,     0,    38,     0,     0,     0,     0,
      41,     0,    45,    46,     5,    23,     0,    48,    49,    25,
       0,     6,     7,     0,     0,     0,    45,    46,     5,     0,
     248,    48,    49,     0,     0,     6,     7,     0,     0,    13,
      69,    14,   415,    38,     0,     0,   119,   120,    41,   505,
      13,     0,    14,   506,     0,     0,     0,    23,   122,     0,
       0,    25,     0,     0,    45,    46,     5,     0,    23,    48,
      49,     0,    25,     6,     7,     0,     0,   127,   128,     0,
     130,   131,    69,     0,     0,    38,     0,   150,     0,   151,
      41,   132,   133,    69,     0,     0,    38,     0,     0,     0,
       0,    41,   150,   134,   151,   152,    45,    46,     5,   153,
       0,    48,    49,     0,     0,     6,     7,    45,    46,     5,
     152,     0,    48,    49,   153,     0,     6,     7,     0,     0,
     154,     0,     0,   155,     0,     0,     0,   466,   156,     0,
     374,   375,   376,     0,   377,   154,     0,     0,   155,     0,
       0,     0,     0,   156,   157,     0,     5,   473,     0,   158,
       0,     0,     0,     6,     7,     0,     0,     0,   378,   157,
       0,     5,   267,   268,   158,     0,     0,     0,     6,     7,
       0,     0,   267,   374,   375,   376,     0,   377,     0,   379,
       0,     5,     0,     0,   380,   381,   382,   383,     6,     7,
     548,     0,     0,   269,   270,     0,   271,   272,     0,     0,
       0,   378,     0,   269,   270,     0,   271,   273,   274,     0,
       0,     0,     0,     0,     0,     0,   361,   273,   274,   275,
       0,     0,   379,     0,     5,     0,     0,   380,   381,   382,
     383,     6,     7,   119,   120,   121,     0,     0,     0,   267,
     268,     0,    16,     0,     0,   122,     0,     0,     0,     0,
     123,   124,     0,     0,     0,    24,     0,   125,     0,   126,
      26,     0,    28,     0,   127,   128,   129,   130,   131,     0,
     269,   270,     0,   271,   119,   120,   121,     0,   132,   133,
      36,    37,     0,    16,   273,   274,   122,     0,     0,     0,
     134,   123,   124,     0,     0,     0,   174,     0,   125,     0,
     126,    26,     0,    28,     0,   127,   128,   129,   130,   131,
       0,   119,   120,   121,     0,     0,     0,     0,     0,   132,
     133,    36,    37,   122,     0,     0,     0,     0,   123,   124,
       0,   134,     0,     0,     0,   125,     0,   126,   119,   120,
       0,   315,   127,   128,   129,   130,   131,   119,   120,     0,
     122,     0,     0,     0,   325,     0,   132,   133,     0,   122,
       0,     0,     0,     0,     0,     0,     0,     0,   134,   127,
     128,     0,   130,   131,     0,     0,     0,     0,   127,   128,
       0,   130,   131,   132,   133,     0,     0,   119,   120,     0,
       0,     0,   132,   133,   503,   134,     0,   -91,   -91,   122,
       0,     0,   -91,     0,   134,   119,   120,     0,     0,     0,
     -91,     0,     0,     0,     0,     0,   213,   122,   127,   128,
       0,   130,   131,   119,   120,     0,     0,   -91,     0,     0,
     -91,     0,   132,   133,     0,   122,   127,   128,     0,   130,
     131,     0,   534,     0,   134,   -91,     0,   119,   120,     0,
     132,   133,     0,     0,   127,   128,     0,   130,   131,   122,
     556,     0,   134,   119,   120,     0,     0,     0,   132,   133,
     559,     0,     0,     0,     0,   122,     0,     0,   127,   128,
     134,   130,   131,     0,   557,     0,     0,   119,   120,     0,
       0,     0,   132,   133,   127,   128,     0,   130,   131,   122,
       0,     0,     0,     0,   134,   119,   120,     0,   132,   133,
       0,     0,     0,     0,   119,   120,     0,   122,   127,   128,
     134,   130,   131,     0,   560,     0,   122,     0,     0,     0,
       0,     0,   132,   133,   267,   268,   127,   128,     0,   130,
     131,     0,   578,     0,   134,   127,   128,     0,   130,   131,
     132,   133,   267,   268,     0,     0,     0,     0,     0,   132,
     133,     0,   134,   396,     0,   269,   270,     0,   271,   272,
       0,   134,   119,   120,     0,     0,     0,     0,     0,   273,
     274,     0,     0,   269,   270,     0,   271,   272,     0,     0,
       0,   275,     0,     0,     0,     0,     0,   273,   274,     0,
       0,     0,     0,   127,   128,     0,   130,   131,     0,   275,
       0,     0,     0,     0,     0,     0,     0,   132,   133,   445,
     446,   447,   448,   449,   450,   451,   452,     0,     0,   134,
       0,     5,     0,     0,     0,     0,     0,     0,     6,     7
  };

  const short
  parser::yycheck_[] =
  {
       2,    11,     4,   116,   138,   137,    53,    25,     4,   277,
      12,    13,   101,    15,    63,   388,    18,    19,   147,   321,
     199,   176,    24,   143,   147,   391,   392,   444,    24,   377,
      32,    33,    34,    35,    94,    18,     4,    84,    40,    53,
     175,    43,   376,    42,    29,   386,     9,   179,    50,    32,
      33,    14,   138,    10,    14,    10,   163,    59,   165,   166,
      14,    63,   169,    59,     0,    42,    10,    50,    22,   116,
      28,    73,    10,    91,    76,   283,   284,    79,   562,    81,
      57,   565,    49,    79,    41,    53,    41,    14,   454,   136,
      48,     9,    10,    78,     9,    10,    98,    41,   386,     5,
     102,   474,   151,    72,    42,   154,   213,   156,    75,   241,
      14,   224,    72,   115,   598,    82,    83,    14,   167,    57,
      14,   135,    25,   246,    42,    80,    81,    42,     9,   176,
      25,   479,   115,    14,    28,    28,   138,   478,   293,    57,
     295,   475,    57,    10,    28,    42,    28,    14,   150,   151,
     149,   153,   154,   526,   156,    48,   573,   292,   218,   219,
     289,   340,   341,   297,   296,   167,   252,   135,    25,    61,
      62,   170,   174,   175,   281,    42,    28,   224,   174,   226,
     293,    28,   311,    39,   186,    28,    42,   189,   396,   606,
     478,    39,   175,   189,    42,    25,   569,    10,   564,   501,
     502,    14,   201,    39,   552,    49,    42,     5,   207,    49,
       6,    28,     8,   215,    10,    41,    42,   583,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   347,    24,    42,
      48,    75,    28,   356,   354,    75,    14,   326,    82,    83,
       9,   529,    82,    83,    39,    41,   293,    42,   427,    10,
     252,   430,   407,    49,   522,   543,    52,    41,    42,   319,
     528,    57,    42,   323,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,    49,   277,    41,    73,    48,    75,
     412,   415,    78,   301,     3,     4,    82,    83,   417,    26,
     292,     9,    10,   581,   407,   297,    14,   344,   316,    26,
      75,    39,    10,    75,    42,   593,    14,    82,    83,   292,
     359,    39,   600,    14,    42,    34,    35,     4,    37,     6,
      75,     8,    25,    39,    42,    12,    42,    82,    83,    48,
      49,    18,    28,   462,    42,    41,    42,    24,    25,    14,
     342,    28,    28,    30,    48,    32,    41,    42,   350,   483,
     352,   480,    41,    42,   350,   357,   352,   359,    34,    35,
     407,    37,    49,    50,    51,    52,    53,    25,     4,    21,
      57,    73,    48,   375,   376,   377,    41,    42,    14,   389,
      41,    42,    80,    81,   386,     4,    73,    74,    75,    25,
      14,    78,    79,     5,    30,    82,    83,    34,    35,    35,
      37,    41,    42,    42,   406,    41,     9,    10,    20,    21,
     406,    48,    10,   415,    50,    27,    73,    29,   547,   468,
      63,    57,   424,    14,    36,    68,    69,    70,   424,    82,
      83,    64,    65,    69,    66,    67,    14,    26,   440,    48,
      25,    41,   444,    79,    63,    64,    65,    66,    67,    68,
      69,    70,    73,    10,    37,    91,    75,    93,    94,     9,
      28,    97,    41,    82,    83,    26,   468,    73,    14,    14,
      10,     9,    14,   475,    73,    14,   478,   479,    14,   115,
     498,   483,   118,   119,   120,    73,   122,    14,    10,    41,
      77,   127,   128,    10,   130,   131,   132,   133,   134,   135,
      41,   137,    37,    28,   514,     9,    10,   143,    10,   145,
      14,    42,     9,   515,    26,    26,   518,    40,    22,   529,
     522,    14,   518,    14,    28,    14,   528,   163,    14,   165,
     166,    40,    14,   169,   536,    39,     9,    40,    42,   175,
     536,    41,     3,   179,     4,    39,     6,    42,     8,   185,
     552,    39,    12,    57,   190,    26,    10,    25,    18,   569,
      41,    48,    14,    73,    24,    25,    40,     9,    28,     9,
      30,   573,    32,    34,    35,    40,    37,   213,    42,    10,
     216,    39,   218,   219,    10,    10,    25,    48,    49,    49,
      50,    51,    52,    53,     9,    10,    73,    57,    10,    14,
      10,    39,    10,   357,   606,   241,   242,    22,    91,   153,
     498,   528,   406,    73,    74,    75,     4,   581,    78,    79,
     608,    81,    82,    83,    39,   515,   515,    42,    -1,     4,
      -1,     6,    -1,     8,    -1,    -1,    -1,    12,    -1,    -1,
      -1,    -1,    57,    18,    -1,   281,    -1,    -1,    -1,    24,
      25,     9,    -1,    28,    -1,    30,   292,    32,    -1,   295,
     296,    -1,    -1,    -1,    -1,   301,    24,    25,    26,    -1,
      28,    -1,    -1,    -1,    49,    50,    51,    52,    53,   315,
     316,    -1,    57,   319,    -1,    -1,    -1,   323,    -1,   325,
      -1,   327,    -1,    -1,    52,    -1,   332,    -1,    73,    74,
      75,    -1,    -1,    78,    79,    -1,    81,    82,    83,   345,
      -1,   347,    -1,    -1,    -1,    73,    -1,    75,   354,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,     0,     1,
      -1,    -1,     4,    -1,     6,    -1,     8,    -1,    -1,    11,
      12,    -1,    14,    -1,    16,    17,    18,    -1,    -1,    -1,
      22,    23,    24,    25,    -1,    -1,    28,    -1,    30,    31,
      32,    33,    -1,    -1,    -1,   401,    -1,    -1,    -1,    -1,
      -1,    43,    44,    45,    46,    47,   412,    49,    50,    51,
      52,    53,    54,    -1,    -1,    57,    -1,    59,    -1,    -1,
      24,    25,    26,    -1,    28,    -1,    -1,    -1,    -1,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    -1,    81,
      82,    83,     5,     6,    -1,     8,    -1,    -1,    52,    -1,
      -1,    -1,    -1,    -1,     9,    10,    -1,    20,    21,    14,
      -1,    24,    -1,    -1,    27,    28,    29,    22,    -1,    73,
      -1,    75,    -1,    36,    78,    79,    80,    81,    82,    83,
     486,   487,    -1,    -1,    39,    -1,    49,    42,    -1,    52,
      -1,    -1,   498,    -1,    57,    -1,    -1,   503,    -1,   505,
     506,    -1,    57,     6,    -1,     8,    -1,    -1,    -1,    12,
      73,    74,    75,    -1,    -1,    78,    79,    -1,    -1,    82,
      83,    24,    25,    -1,    -1,    28,    -1,    30,    -1,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     6,    -1,
       8,    -1,    -1,    -1,    12,    -1,    49,    50,    51,    52,
      -1,    -1,    -1,   559,    57,    -1,    24,    25,    -1,    -1,
      28,    -1,    30,    -1,    32,    -1,    -1,    -1,    -1,    -1,
      73,    74,    75,    -1,    -1,    78,    79,    -1,    -1,    82,
      83,    49,    50,    51,    52,    -1,     6,    -1,     8,    57,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,    18,    -1,
       6,    -1,     8,    -1,    24,    73,    74,    75,    28,    -1,
      78,    79,    18,    -1,    82,    83,    -1,    -1,    24,    39,
      -1,    -1,    28,    -1,    -1,    -1,    -1,    34,    35,    49,
      37,    38,    52,    53,    -1,    -1,    42,    57,     6,    -1,
       8,    48,    49,    49,    -1,    -1,    52,    53,    -1,    -1,
      18,    57,    -1,    73,    74,    75,    24,    -1,    78,    79,
      28,    81,    82,    83,    -1,    -1,    -1,    73,    74,    75,
      -1,    39,    78,    79,    -1,    81,    82,    83,    -1,    -1,
       6,    49,     8,    -1,    52,    53,    -1,    -1,    -1,    57,
      -1,    -1,    18,    -1,    -1,    -1,    -1,    -1,    24,    -1,
      -1,    -1,    28,    -1,    -1,    73,    74,    75,    -1,    -1,
      78,    79,    -1,    81,    82,    83,    42,     6,    -1,     8,
      -1,    -1,    -1,    49,    -1,    -1,    52,    53,     6,    18,
       8,    57,    -1,    -1,    -1,    24,    -1,    -1,    -1,    28,
      18,    -1,    -1,    -1,    -1,    -1,    24,    73,    74,    75,
      28,    -1,    78,    79,    -1,    81,    82,    83,    -1,    -1,
      49,    -1,    -1,    52,    53,     6,    -1,     8,    57,    -1,
      -1,    49,    -1,    -1,    52,    53,    -1,    18,    -1,    57,
      -1,    -1,    -1,    24,    73,    74,    75,    28,    -1,    78,
      79,    -1,    81,    82,    83,    73,    74,    75,    -1,    -1,
      78,    79,    -1,    81,    82,    83,    -1,     6,    49,     8,
       9,    52,    53,    -1,    -1,    -1,    57,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    24,     6,    -1,     8,    28,
      10,    -1,    73,    74,    75,    -1,    -1,    78,    79,    -1,
      39,    82,    83,    -1,    24,    -1,    -1,    -1,    28,    -1,
      49,    -1,    -1,    52,    -1,     3,     4,    -1,    57,    -1,
      -1,     9,    -1,     6,    -1,     8,    14,    15,    -1,    49,
      -1,    14,    52,    -1,    73,    74,    75,    57,    -1,    78,
      79,    24,    -1,    82,    83,    28,    34,    35,    -1,    37,
      38,    -1,    -1,    73,    74,    75,    -1,    -1,    78,    79,
      48,    49,    82,    83,    -1,     6,    49,     8,    -1,    52,
      -1,    -1,    60,    -1,    57,     3,     4,    -1,    -1,     6,
      -1,     8,    -1,    24,    -1,    -1,    -1,    28,    -1,    -1,
      73,    74,    75,    -1,    -1,    78,    79,    24,    39,    82,
      83,    28,    -1,    -1,    -1,    -1,    34,    35,    49,    37,
      38,    52,    39,    -1,    -1,    -1,    57,     6,    -1,     8,
      48,    49,    49,    -1,    -1,    52,    -1,    -1,    -1,    -1,
      57,    -1,    73,    74,    75,    24,    -1,    78,    79,    28,
      -1,    82,    83,    -1,    -1,    -1,    73,    74,    75,    -1,
      39,    78,    79,    -1,    -1,    82,    83,    -1,    -1,     6,
      49,     8,     9,    52,    -1,    -1,     3,     4,    57,     6,
       6,    -1,     8,    10,    -1,    -1,    -1,    24,    15,    -1,
      -1,    28,    -1,    -1,    73,    74,    75,    -1,    24,    78,
      79,    -1,    28,    82,    83,    -1,    -1,    34,    35,    -1,
      37,    38,    49,    -1,    -1,    52,    -1,     6,    -1,     8,
      57,    48,    49,    49,    -1,    -1,    52,    -1,    -1,    -1,
      -1,    57,     6,    60,     8,    24,    73,    74,    75,    28,
      -1,    78,    79,    -1,    -1,    82,    83,    73,    74,    75,
      24,    -1,    78,    79,    28,    -1,    82,    83,    -1,    -1,
      49,    -1,    -1,    52,    -1,    -1,    -1,    41,    57,    -1,
      24,    25,    26,    -1,    28,    49,    -1,    -1,    52,    -1,
      -1,    -1,    -1,    57,    73,    -1,    75,    41,    -1,    78,
      -1,    -1,    -1,    82,    83,    -1,    -1,    -1,    52,    73,
      -1,    75,     3,     4,    78,    -1,    -1,    -1,    82,    83,
      -1,    -1,     3,    24,    25,    26,    -1,    28,    -1,    73,
      -1,    75,    -1,    -1,    78,    79,    80,    81,    82,    83,
      41,    -1,    -1,    34,    35,    -1,    37,    38,    -1,    -1,
      -1,    52,    -1,    34,    35,    -1,    37,    48,    49,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    57,    48,    49,    60,
      -1,    -1,    73,    -1,    75,    -1,    -1,    78,    79,    80,
      81,    82,    83,     3,     4,     5,    -1,    -1,    -1,     3,
       4,    -1,    12,    -1,    -1,    15,    -1,    -1,    -1,    -1,
      20,    21,    -1,    -1,    -1,    25,    -1,    27,    -1,    29,
      30,    -1,    32,    -1,    34,    35,    36,    37,    38,    -1,
      34,    35,    -1,    37,     3,     4,     5,    -1,    48,    49,
      50,    51,    -1,    12,    48,    49,    15,    -1,    -1,    -1,
      60,    20,    21,    -1,    -1,    -1,    25,    -1,    27,    -1,
      29,    30,    -1,    32,    -1,    34,    35,    36,    37,    38,
      -1,     3,     4,     5,    -1,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    15,    -1,    -1,    -1,    -1,    20,    21,
      -1,    60,    -1,    -1,    -1,    27,    -1,    29,     3,     4,
      -1,     6,    34,    35,    36,    37,    38,     3,     4,    -1,
      15,    -1,    -1,    -1,    10,    -1,    48,    49,    -1,    15,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,    34,
      35,    -1,    37,    38,    -1,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    48,    49,    -1,    -1,     3,     4,    -1,
      -1,    -1,    48,    49,    10,    60,    -1,     9,    10,    15,
      -1,    -1,    14,    -1,    60,     3,     4,    -1,    -1,    -1,
      22,    -1,    -1,    -1,    -1,    -1,    28,    15,    34,    35,
      -1,    37,    38,     3,     4,    -1,    -1,    39,    -1,    -1,
      42,    -1,    48,    49,    -1,    15,    34,    35,    -1,    37,
      38,    -1,    40,    -1,    60,    57,    -1,     3,     4,    -1,
      48,    49,    -1,    -1,    34,    35,    -1,    37,    38,    15,
      40,    -1,    60,     3,     4,    -1,    -1,    -1,    48,    49,
      10,    -1,    -1,    -1,    -1,    15,    -1,    -1,    34,    35,
      60,    37,    38,    -1,    40,    -1,    -1,     3,     4,    -1,
      -1,    -1,    48,    49,    34,    35,    -1,    37,    38,    15,
      -1,    -1,    -1,    -1,    60,     3,     4,    -1,    48,    49,
      -1,    -1,    -1,    -1,     3,     4,    -1,    15,    34,    35,
      60,    37,    38,    -1,    40,    -1,    15,    -1,    -1,    -1,
      -1,    -1,    48,    49,     3,     4,    34,    35,    -1,    37,
      38,    -1,    40,    -1,    60,    34,    35,    -1,    37,    38,
      48,    49,     3,     4,    -1,    -1,    -1,    -1,    -1,    48,
      49,    -1,    60,    14,    -1,    34,    35,    -1,    37,    38,
      -1,    60,     3,     4,    -1,    -1,    -1,    -1,    -1,    48,
      49,    -1,    -1,    34,    35,    -1,    37,    38,    -1,    -1,
      -1,    60,    -1,    -1,    -1,    -1,    -1,    48,    49,    -1,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,    60,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    63,
      64,    65,    66,    67,    68,    69,    70,    -1,    -1,    60,
      -1,    75,    -1,    -1,    -1,    -1,    -1,    -1,    82,    83
  };

  const unsigned char
  parser::yystos_[] =
  {
       0,    61,    62,    85,    86,    75,    82,    83,    88,   134,
       0,     1,     4,     6,     8,    11,    12,    14,    16,    17,
      18,    22,    23,    24,    25,    28,    30,    31,    32,    33,
      43,    44,    45,    46,    47,    49,    50,    51,    52,    53,
      54,    57,    59,    71,    72,    73,    74,    76,    78,    79,
      81,    87,    88,    92,   102,   104,   108,   118,   119,   122,
     123,   127,   148,     5,    72,   162,    88,   147,    88,    49,
      88,    92,    88,    49,    88,   102,    49,    88,    14,   124,
     125,    29,    78,    39,    92,   104,   117,    10,    92,    94,
      96,    97,    98,    25,    25,    14,    92,    28,    49,    88,
     102,   102,    49,    88,    88,    92,    88,    92,    93,    14,
     125,    88,    28,    18,    53,    81,    92,   102,    28,     3,
       4,     5,    15,    20,    21,    27,    29,    34,    35,    36,
      37,    38,    48,    49,    60,   101,   103,   118,     9,    10,
      42,    57,   121,    25,    92,   101,   114,   104,    14,    22,
       6,     8,    24,    28,    49,    52,    57,    73,    78,    88,
      89,    14,    72,    28,   160,    28,    28,     5,    88,    28,
       9,    14,    88,    48,    25,    81,    92,   104,   108,   113,
     115,   120,   148,    88,    14,   101,     9,   107,    39,    42,
      10,    42,    96,    41,    39,    92,   129,   132,    39,   129,
     133,     9,    14,    92,   100,    88,    48,     9,    14,   126,
     126,    88,    48,    28,    14,    28,    42,    57,    26,    26,
     161,    75,    18,    53,    92,   102,   103,    94,    95,    99,
      92,    92,    92,    92,    92,    92,    92,    92,    92,    92,
      92,   118,   101,   114,    42,   104,   105,   106,    39,    95,
     116,    92,     9,    10,   107,   121,    14,   125,    88,    89,
      10,    41,    89,    90,    89,    89,    28,     3,     4,    34,
      35,    37,    38,    48,    49,    60,    99,    25,    99,    99,
      89,    28,    99,    14,   125,   135,    48,    73,    39,   104,
     111,   112,    81,    92,   115,   101,   113,     9,    10,    14,
      42,    25,   114,    10,    14,    42,    14,    42,    21,   105,
     106,   104,    92,    42,    14,     6,    10,   128,    39,    42,
      14,   128,    39,    42,   125,    10,    41,    42,    48,    73,
      14,   125,    26,    48,    73,    99,    88,   136,   137,    92,
     129,   129,    25,    41,   103,    10,    41,    42,   114,    92,
      10,   121,     9,    39,    42,    42,   105,    28,    41,    10,
      41,    57,    90,    91,    89,    89,    89,    89,    89,    89,
      89,    89,    89,    41,    24,    25,    26,    28,    52,    73,
      78,    79,    80,    81,    88,   138,   139,   140,   141,   142,
     144,   145,   146,   162,    41,    41,    14,    99,    41,   135,
     135,    26,    73,    14,   107,    39,    42,    92,   115,    10,
      14,    42,   113,   114,   106,     9,    39,    94,   109,   110,
      14,   107,    92,    94,     9,   131,    14,   129,   131,    14,
     129,    92,   126,    92,    73,    14,    92,    73,    14,    41,
      10,    41,   128,   128,     4,    63,    64,    65,    66,    67,
      68,    69,    70,    88,   154,   155,   157,   158,   159,    77,
      95,   104,   104,    95,   121,    91,    41,    89,    10,    41,
     142,   143,   143,    41,   141,    28,   138,   140,   139,    10,
     162,   160,   160,     9,   135,    41,    26,    26,    92,    14,
     111,    10,    14,    42,   114,   106,   107,    39,    42,   104,
     130,   128,   128,    10,    14,     6,    10,    14,    88,    14,
      40,    40,   154,   160,    39,    42,    14,   107,     9,    41,
      39,    40,    10,    41,   143,   140,   141,   107,    42,    39,
     106,    26,    92,    92,    40,   109,    10,   131,   131,    92,
      92,    92,    48,    25,   162,   155,   157,   104,    41,   142,
      41,   144,   138,   162,    82,    83,    40,    40,   104,    10,
      40,    73,   138,   151,   152,   153,    14,   107,    41,   141,
      40,    40,    92,     9,   161,   160,   161,   162,    40,   154,
       9,    42,    39,    10,    73,   151,    63,    68,    69,    70,
     156,   160,    10,    25,    64,    65,   138,   149,   150,    10,
      10,   161,    66,    67,   138,    39,    10,   154,    10,   156
  };

  const unsigned char
  parser::yyr1_[] =
  {
       0,    84,    85,    85,    86,    86,    87,    87,    87,    87,
      88,    88,    88,    89,    89,    89,    89,    89,    89,    89,
      89,    89,    89,    89,    89,    89,    89,    89,    89,    89,
      89,    89,    89,    89,    89,    89,    89,    90,    90,    91,
      91,    92,    92,    92,    92,    92,    92,    92,    92,    92,
      92,    92,    92,    92,    92,    92,    92,    92,    92,    92,
      92,    92,    92,    92,    92,    93,    93,    94,    94,    95,
      95,    96,    96,    96,    96,    97,    97,    98,    98,    99,
      99,   100,   100,   101,   101,   101,   101,   101,   101,   102,
     102,   102,   102,   103,   103,   104,   104,   104,   104,   104,
     104,   104,   104,   104,   104,   104,   104,   105,   105,   106,
     106,   107,   107,   108,   108,   108,   108,   108,   109,   109,
     110,   110,   111,   112,   112,   113,   113,   113,   113,   114,
     114,   114,   115,   115,   115,   115,   116,   116,   117,   117,
     118,   118,   118,   118,   119,   119,   119,   119,   120,   121,
     121,   122,   122,   122,   122,   122,   122,   122,   122,   123,
     123,   124,   124,   124,   124,   124,   124,   124,   124,   124,
     124,   125,   125,   125,   125,   125,   126,   126,   126,   127,
     127,   127,    87,    87,    87,    87,    87,   128,   128,   129,
     129,   130,   130,   131,   131,   131,    87,    87,   132,   132,
     133,   133,    87,    87,    87,    87,    87,    87,    87,    87,
      87,    87,    87,    87,    87,    87,    87,    87,    87,   134,
     135,    87,    87,    87,    87,    87,    87,   136,   136,   137,
     137,    87,    87,    87,    87,    87,    87,    87,    87,   138,
     138,   139,   139,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   141,   141,   141,   142,
     142,   143,   143,   144,   144,   145,   145,   146,   146,   147,
     147,   148,   148,   148,   149,   149,   150,   150,   151,   151,
     151,   152,   152,   153,   153,   154,   154,   154,   154,   154,
     154,   154,   154,   154,   155,   156,   156,   156,   156,   157,
     157,   158,   158,   158,   158,   159,   159,    87,   160,   161,
     162
  };

  const signed char
  parser::yyr2_[] =
  {
       0,     2,     2,     3,     2,     0,     1,     1,     3,     3,
       1,     1,     1,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     2,     2,     3,     3,     4,     4,     5,
       3,     1,     2,     1,     1,     1,     1,     1,     3,     1,
       0,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     2,     3,     4,     5,     3,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     3,     1,
       0,     2,     1,     1,     0,     2,     3,     1,     2,     1,
       3,     3,     5,     1,     1,     1,     1,     1,     1,     1,
       4,     2,     5,     2,     3,     1,     2,     3,     1,     2,
       3,     1,     2,     3,     2,     3,     4,     1,     3,     1,
       0,     2,     0,     1,     1,     1,     1,     1,     2,     2,
       1,     3,     2,     1,     3,     2,     3,     3,     4,     1,
       2,     0,     3,     4,     2,     1,     6,     4,     2,     4,
       3,     4,     2,     3,     3,     4,     2,     1,     3,     1,
       1,     3,     3,     4,     5,     2,     2,     4,     3,     3,
       3,     3,     3,     3,     3,     4,     4,     5,     5,     3,
       0,     3,     3,     4,     5,     3,     1,     2,     2,     1,
       1,     1,     2,     3,     3,     2,     2,     2,     0,     3,
       1,     1,     3,     2,     1,     0,     6,     6,     3,     5,
       3,     5,     4,     4,     5,     5,     5,     6,     2,     4,
       3,     5,     6,     5,    10,     8,     5,     6,     3,     3,
       0,     6,     9,     9,     6,     3,     5,     3,     1,     0,
       1,     6,     3,     5,     5,     4,     8,     8,     7,     1,
       1,     2,     1,     3,     3,     2,     3,     4,     5,     4,
       1,     1,     1,     1,     1,     1,     3,     2,     1,     3,
       1,     1,     0,     3,     3,     4,     1,     1,     0,     1,
       4,     2,     8,    10,     1,     3,     1,     0,     6,     8,
       8,     1,     4,     1,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     6,     1,     1,     1,     1,    16,
       8,     3,     3,     1,     1,     1,     0,     8,     0,     0,
       0
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const parser::yytname_[] =
  {
  "\"<EOF>\"", "error", "\"invalid token\"", "\"+\"", "\"&\"", "\"=\"",
  "\"@\"", "\"#base\"", "\"~\"", "\":\"", "\",\"", "\"#const\"",
  "\"#count\"", "\"#cumulative\"", "\".\"", "\"..\"", "\"#external\"",
  "\"#defined\"", "\"#false\"", "\"#forget\"", "\">=\"", "\">\"", "\":-\"",
  "\"#include\"", "\"#inf\"", "\"{\"", "\"[\"", "\"<=\"", "\"(\"", "\"<\"",
  "\"#max\"", "\"#maximize\"", "\"#min\"", "\"#minimize\"", "\"\\\\\"",
  "\"*\"", "\"!=\"", "\"**\"", "\"?\"", "\"}\"", "\"]\"", "\")\"", "\";\"",
  "\"#show\"", "\"#edge\"", "\"#project\"", "\"#heuristic\"",
  "\"#showsig\"", "\"/\"", "\"-\"", "\"#sum\"", "\"#sum+\"", "\"#sup\"",
  "\"#true\"", "\"#program\"", "UBNOT", "UMINUS", "\"|\"", "\"#volatile\"",
  "\":~\"", "\"^\"", "\"<program>\"", "\"<define>\"", "\"any\"",
  "\"unary\"", "\"binary\"", "\"left\"", "\"right\"", "\"head\"",
  "\"body\"", "\"directive\"", "\"#theory\"", "\"EOF\"", "\"<NUMBER>\"",
  "\"<ANONYMOUS>\"", "\"<IDENTIFIER>\"", "\"<SCRIPT>\"", "\"<CODE>\"",
  "\"<STRING>\"", "\"<VARIABLE>\"", "\"<THEORYOP>\"", "\"not\"",
  "\"default\"", "\"override\"", "$accept", "start", "program",
  "statement", "identifier", "constterm", "consttermvec", "constargvec",
  "term", "unaryargvec", "ntermvec", "termvec", "tuple", "tuplevec_sem",
  "tuplevec", "argvec", "binaryargvec", "cmp", "atom", "rellitvec",
  "literal", "nlitvec", "litvec", "optcondition", "aggregatefunction",
  "bodyaggrelem", "bodyaggrelemvec", "altbodyaggrelem",
  "altbodyaggrelemvec", "bodyaggregate", "upper", "lubodyaggregate",
  "headaggrelemvec", "altheadaggrelemvec", "headaggregate",
  "luheadaggregate", "conjunction", "dsym", "disjunctionsep",
  "disjunction", "bodycomma", "bodydot", "bodyconddot", "head",
  "optimizetuple", "optimizeweight", "optimizelitvec", "optimizecond",
  "maxelemlist", "minelemlist", "define", "storecomment", "nidlist",
  "idlist", "theory_op", "theory_op_list", "theory_term", "theory_opterm",
  "theory_opterm_nlist", "theory_opterm_list", "theory_atom_element",
  "theory_atom_element_nlist", "theory_atom_element_list",
  "theory_atom_name", "theory_atom", "theory_operator_nlist",
  "theory_operator_list", "theory_operator_definition",
  "theory_operator_definition_nlist", "theory_operator_definiton_list",
  "theory_definition_identifier", "theory_term_definition",
  "theory_atom_type", "theory_atom_definition", "theory_definition_nlist",
  "theory_definition_list", "enable_theory_lexing",
  "enable_theory_definition_lexing", "disable_theory_lexing", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  parser::yyrline_[] =
  {
       0,   318,   318,   319,   323,   324,   330,   331,   332,   333,
     337,   338,   339,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   375,   376,   380,
     381,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   416,   417,   423,   424,   428,
     429,   433,   434,   435,   436,   439,   440,   443,   444,   447,
     448,   452,   453,   463,   464,   465,   466,   467,   468,   472,
     473,   474,   475,   479,   480,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   503,   504,   508,
     509,   513,   514,   518,   519,   520,   521,   522,   528,   529,
     533,   534,   540,   544,   545,   551,   552,   553,   554,   558,
     559,   560,   564,   565,   566,   567,   573,   574,   578,   579,
     585,   586,   587,   588,   592,   593,   594,   595,   602,   609,
     610,   616,   617,   618,   619,   620,   621,   622,   623,   627,
     628,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   648,   649,   650,   651,   652,   656,   657,   658,   661,
     662,   663,   667,   668,   669,   670,   671,   677,   678,   682,
     683,   687,   688,   692,   693,   694,   698,   699,   703,   704,
     708,   709,   713,   714,   715,   716,   722,   723,   724,   725,
     726,   732,   733,   738,   744,   745,   751,   752,   753,   759,
     763,   766,   767,   768,   774,   780,   781,   787,   788,   792,
     793,   797,   798,   804,   805,   806,   807,   808,   809,   815,
     816,   822,   823,   827,   828,   829,   830,   831,   832,   833,
     834,   835,   836,   837,   838,   839,   843,   844,   845,   849,
     850,   854,   855,   859,   860,   864,   865,   869,   870,   874,
     875,   878,   879,   880,   886,   887,   891,   892,   896,   897,
     898,   902,   903,   907,   908,   912,   913,   914,   915,   916,
     917,   918,   919,   920,   924,   928,   929,   930,   931,   935,
     937,   941,   942,   943,   944,   948,   949,   953,   959,   963,
     967
  };

  void
  parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  parser::symbol_kind_type
  parser::yytranslate_ (int t) YY_NOEXCEPT
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const signed char
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83
    };
    // Last valid token kind.
    const int code_max = 338;

    if (t <= 0)
      return symbol_kind::S_YYEOF;
    else if (t <= code_max)
      return static_cast <symbol_kind_type> (translate_table[t]);
    else
      return symbol_kind::S_YYUNDEF;
  }

#line 28 "/builddir/build/BUILD/clingo-5.7.1/libgringo/src/input/nongroundgrammar.yy"
} } } // Gringo::Input::NonGroundGrammar
#line 3666 "/builddir/build/BUILD/clingo-5.7.1/release/libgringo/src/input/nongroundgrammar/grammar.cc"

